/****************************************************************************
 *	file_sel.h: 
 *
 *			Date. 1994/08/13 --
 *				Programed by Nobuyuki Maruichi
 *				Adviced by S.Kouno(ggxsnd)
 *
 *	from
 *		ggxsnd.h
 ****************************************************************************/

#ifndef _FILE_SELECTOR_H
#define _FILE_SELECTOR_H

#include "xfile.h"

/***************************************************************************
 *	PopdownInfo : ݥåץѤξ
 *	С
 *		popupWidget:	ݥåץåפå
 *		popdownShell:	ݥåץ󤵤륷륦å
 *		client_data:	
 ***************************************************************************/
typedef struct _popdownInfo {
	Widget popupWidget;
	Widget popdownShell;
	XtPointer *client_data;
} PopdownInfo;

/***************************************************************************
 *	˥塼: ˥塼ܾ
 *	̻
 *		TypeSme:		˥塼ȥδܥ饹
 *		TypeSmeBSB:		Ūʥ˥塼ȥ
 *		TypeSmeLine:	˥塼ܤΥѥ졼
 ***************************************************************************/
enum _MenuType {TypeSme, TypeSmeBSB, TypeSmeLine};

/***************************************************************************
 *	menu_data ¤: ˥塼ܾ
 *	С
 *		type:			˥塼ܷ
 *		widgetName:		У̣٤ǤΤ߻ѡ̤
 *		myWidget:	
 *		function:		У̣٤ǤΤ߻ѡ̤
 ***************************************************************************/
struct menu_data {
	int type;
	String widgetName;
	Widget myWidget;
	void (*function)(Widget w, XtPointer client_data, XtPointer call_data);
	XtPointer client_data;
};

/***************************************************************************
 *	menuData ¤: ˥塼
 *	С
 *		menuButton:		˥塼ܥΥå
 *		menu:			˥塼Υå
 *		menuName:		˥塼δ̾
 *		num:			˥塼ܤο
 *		info:			˥塼ܾ
 ***************************************************************************/
struct menuData {
	Widget menuButton;
	Widget menu;
	const char *menuName;
	int num;
	void (*popup)(Widget w, XtPointer client_data, XtPointer call_data);
	void (*popdown)(Widget w, XtPointer client_data, XtPointer call_data);
	struct menu_data *info;
};

/***************************************************************************
 *	modeSelector: ⡼˥塼
 *	С
 *		paneNo:			ֹ
 *		menuInfo:		˥塼
 *		blockNo:		֥åֹ
 *		partNo:			ֹ
 *		currentPane:	߹ܤξ
 *		blockTop:		⡼
 ***************************************************************************/
typedef struct _modeSelector {
	int paneNo;
	struct menuData *menuInfo;
	int blockNo;
	int partNo;
	struct menu_data *currentPane;
	struct _modeSelector *blockTop;
	XtPointer client_data;
} modeSelector;

/***************************************************************************
 *	selectorPanes: ⡼˥塼
 *	С
 *		
 *		   С̾   ա̣
 *		
 *		 0paneNo          ֹ桡
 *		
 *		 1panesInfo       ˥塼ܾ
 *		
 *		 2fileSelecterInfoե
 *		
 *		 3option          ץؿ
 *		
 *		 4client_data     
 *		
 ***************************************************************************/
typedef struct _selectorPanes {
	int paneNo;
	struct menu_data **panesInfo;
	FileSelctorInfo *fileSelecterInfo;
	void (*option)(Widget w, XtPointer client_data, XtPointer call_data);
	XtPointer client_data;
} selectorPanes;

/****************************************************************************
 *	fSelectorMenuInfo: 󥰥롦󥯥ȡꥹȷʻȹ¤
 *	С
 *		selectorPanes *filesPickupPane;
 *		selectorPanes *filesSortPane;
 *		void (*selectFinish)(const char *dirName, const char *fileName);
 *	
 *		
 *		
 ***************************************************************************/
typedef struct _fsMenuInfo {
	selectorPanes *filesPickupPane;
	selectorPanes *filesSortPane;
	void (*selectFinish)(const char *dirName, const char *fileName);
} fSelectorMenuInfo;

/*******************
 *	Хѿ
 *******************/
extern selectorPanes filePickupPaneInfo[];
extern selectorPanes fileSortPaneInfo[];

/*********************
 *	ץȥ
 *********************/
Widget fileDialogInit(Widget parent);
void fileSelectorCall(Widget popupButton, const char *dirName, 
			selectorPanes *selectorPane, selectorPanes *sortPane,
 			void selectFinish(const char *dirName, const char *fileName));
int isDirectory(const char *filename);
int fileCheck(const char *filepath, int dirLength, char *dirName, 
									int fileLength, char *fileName);

void selectFinish(const char *dirName, const char *fileName);
void fileSelector(Widget w, XtPointer client_data, XtPointer call_data);

#endif /*_FILE_SELECTOR_H*/

