/***************************************************************************
 *	actree: Athena Widget  Code Conveterter]c[\Ǘ
 *		
 *			Date. 1995/11/18 -- 1995/12/29
 *				Programed by Nobuyuki Maruichi
 *
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208-1983/1990
 *			Tab Size 4 / Shift Width = 4
 ***************************************************************************/

/***********************************************
 *	bWCũCN[ht@C
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <errno.h>
/*************************************
 *	X Toolkit ̃CN[ht@C
 *************************************/
#include <X11/Intrinsic.h>		/* Intrinsics Definitions */
#include <X11/StringDefs.h>		/* Standard Name-String definitions */

#include <X11/Composite.h>
#include <X11/Core.h>
#include <X11/Shell.h>

/*****************************************
 *	Athena Widget ̃CN[ht@C
 *****************************************/
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Grip.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Repeater.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Panner.h>
#include <X11/Xaw/Porthole.h>
#include <X11/Xaw/Tree.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/StripChart.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/TextSrc.h>
#include <X11/Xaw/TextSink.h>
#include <X11/Xaw/AsciiSrc.h>
#include <X11/Xaw/AsciiSink.h>

#include "acconv.h"
#include "file_sel.h"

FILE *load_fp;
FILE *save_fp;

PartsTree *CurrentParts = NULL;
AWidgetInfo *CurrentAwParts = NULL;
String currentWidgetName;
extern Widget mguiList;
extern Widget mguiTree;
void widgetCreater(AWidgetInfo *myWidget, PartsTree *parts);
void shellCreater(AWidgetInfo *myWidget, PartsTree *parts);
Boolean hasParent(AWidgetInfo *myWidget, PartsTree *parts);
Boolean hasChild(AWidgetInfo *myWidget, PartsTree *parts);
Boolean hasFamily(AWidgetInfo *myWidget, PartsTree *parts);
Boolean hasNoFamily(AWidgetInfo *myWidget, PartsTree *parts);
Boolean hasNormalChild(AWidgetInfo *myWidget, PartsTree *parts);
Boolean partsExist(AWidgetInfo *myWidget, PartsTree *parts);
Boolean alwaysMakable(AWidgetInfo *myWidget, PartsTree *parts);
Boolean alwaysDismakable(AWidgetInfo *myWidget, PartsTree *parts);
void makableObject(PartsTree *parts);
void partsRenewal(PartsTree *parts);

/**************************************************************************
 *	argumentArrayProc[]FiǗ񂩂̕𓾂֐iQj
 *	`
 *		char *(*argumentArrayProc[])(PartsTree *parts);
 *	
 *		PartsTree *parts;		iǗ
 *	Ԃl
 *		NULL:		G[
 *		NULLȊO:	
 *	
 *		@̔źAiǗ񂩂̕𓾂֐ւ̃|C^
 *		złBۂɂ́Az̓YɂĊl̎ʂ
 *		܂Bz̓ÝANoArg(0) ȏŁAVariableTypeNum 
 *		Ȃ܂B
 *		z̓ŸӖ
 *			NoArg = 0:			YȂiY̔z̏I[op *			ArgWidget:			EBWFbgϐ *			ArgWidgetName:		EBWFbg
 *			ArgWidgetClass:		NXϐ
 *			ArgParent:			eEBWFbgϐ
 *			ArgAppContext:		AvP[VReNXgϐ
 *			ArgApplicationClass:AvP[VNX
 *			VariableTypeNum:	Y͈̓I[o[li͈͊Oopj
 *		̒lɑΉāAX̓Y쐬p̊֐R[B
 *		
 *	QƎ
 *		Y쐬p̊֐
 *			char *noArg(PartsTree *parts);			c	Ȃ
 *			char *argWidget(PartsTree *parts);		c	EBWFbgϐ
 *			char *argWidgetName(PartsTree *parts);	c	EBWFbg
 *			char *argWidgetClass(PartsTree *parts);	c	NXϐ
 *			char *argParent(PartsTree *parts);		c	eEBWFbgϐ
 *			char *argAppContext(PartsTree *parts);
 *									c	AvP[VReNXgϐ
 *			char *argApplicationClass(PartsTree *parts);
 *											c	AvP[VNX
 ***************************************************************************/
char *(*argumentArrayProc[])(PartsTree *parts) = {
	noArg, argWidget, argWidgetName, argWidgetClass,
	argParent, argAppContext, argApplicationClass
};

static char **widgetList = NULL;
static AWidgetInfo **awidgetInfo = NULL;
StringsLink *sourceList = NULL;
StringsLink *copyBufferList = NULL;

int createApplicationArgs[] = 
	{ArgWidget, ArgApplicationClass, NoArg};
char createApplication[] = 
	"\t%s = XtVaAppInitialize(\n"
	"\t\t\t\t&app_context,\n"
	"\t\t\t\t\"%s\",\n"
	"\t\t\t\tNULL, 0,\n"
	"\t\t\t\t&argc, argv,\n"
	"\t\t\t\tNULL, \n"
	"\t\t\t\tNULL);\n";

int createShellArgs[] = 
	{ArgWidget, ArgWidgetName, ArgWidgetClass, ArgParent, NoArg};
char createShell[] = 
	"\t%s = XtVaCreatePopupShell(\n"
	"\t\t\t\t\"%s\",\n"
	"\t\t\t\t%s,\n"
	"\t\t\t\t%s,\n"
	"\t\t\t\tNULL);\n";

int createNormalArgs[] = 
	{ArgWidget, ArgWidgetName, ArgWidgetClass, ArgParent, NoArg};
char createNormal[] = 
	"\t%s = XtVaCreateManagedWidget(\n"
	"\t\t\t\t\"%s\",\n"
	"\t\t\t\t%s,\n"
	"\t\t\t\t%s,\n"
	"\t\t\t\tNULL);\n";

AWidgetInfo widgetSet[] = {
	{
		"#include <X11/Composite.h>", 	/* CN[hEt@C */
		"Composite", 					/* NX */
		"compositeWidgetClass",			/* ϐiNXE|C^j */
		&compositeWidgetClass,			/* NXϐiNXE|C^j */
		NULL, 							/* CX^XtH[}bg */
		NULL, 							/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		MetaClass, 						/* i */
		NULL, 							/* č\\֐ */
		NULL, 							/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		NULL							/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Box.h>",  	/* CN[hEt@C */
		"Box", 							/* NX */
		"boxWidgetClass", 				/* ϐiNXE|C^j */
		&boxWidgetClass, 				/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		MultiChild,						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasFamily, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Constraint.h>",  /* CN[hEt@C */
		"Constraint", 					/* NX */
		"constraintWidgetClass",		/* ϐiNXE|C^j */
		&constraintWidgetClass,			/* NXϐiNXE|C^j */
		NULL, 							/* CX^XtH[}bg */
		NULL, 							/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		MetaClass, 						/* i */
		NULL, 							/* č\\֐ */
		NULL, 							/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		NULL							/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Form.h>", 	/* CN[hEt@C */
		"Form", 						/* NX */
		"formWidgetClass",				/* ϐiNXE|C^j */
		&formWidgetClass,				/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		MultiChild,						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Dialog.h>", 	/* CN[hEt@C */
		"Dialog", 						/* NX */
		"dialogWidgetClass",			/* ϐiNXE|C^j */
		&dialogWidgetClass,				/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		MultiChild,						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Viewport.h>",/* CN[hEt@C */
		"Viewport", 					/* NX */
		"viewportWidgetClass",			/* ϐiNXE|C^j */
		&viewportWidgetClass,			/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		MultiChild,						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasFamily, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Paned.h>", 	/* CN[hEt@C */
		"Paned", 						/* NX */
		"panedWidgetClass",				/* ϐiNXE|C^j */
		&panedWidgetClass,				/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		MultiChild,						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasFamily, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Tree.h>", 	/* CN[hEt@C */
		"Tree", 						/* NX */
		"treeWidgetClass",				/* ϐiNXE|C^j */
		&treeWidgetClass,				/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		MultiChild,						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Porthole.h>",/* CN[hEt@C */
		"Porthole", 					/* NX */
		"portholeWidgetClass",			/* ϐiNXE|C^j */
		&portholeWidgetClass,			/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		OneChild, 						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Shell.h>", 		/* CN[hEt@C */
		"OverrideShell", 				/* NX */
		"overrideShellWidgetClass",		/* ϐiNXE|C^j */
		&overrideShellWidgetClass,		/* NXϐiNXE|C^j */
		createShell, 					/* CX^XtH[}bg */
		createShellArgs, 				/* CX^X */
		OneChild, 						/* qEBWFbg̎ */
		ShellWidget,					/* i */
		hasFamily, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		hasNormalChild, 				/* EBWFbg\֐ */
		shellCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/SimpleMenu.h>", 	/* CN[hEt@C */
		"SimpleMenu", 					/* NX */
		"simpleMenuWidgetClass",		/* ϐiNXE|C^j */
		&simpleMenuWidgetClass,			/* NXϐiNXE|C^j */
		createShell, 					/* CX^XtH[}bg */
		createShellArgs, 				/* CX^X */
		OneChild, 						/* qEBWFbg̎ */
		SimpleMenu,						/* i */
		hasFamily, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		shellCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Shell.h>", 		/* CN[hEt@C */
		"TopLevelShell", 				/* NX */
		"topLevelShellWidgetClass",		/* ϐiNXE|C^j */
		&topLevelShellWidgetClass,		/* NXϐiNXE|C^j */
		createShell, 					/* CX^XtH[}bg */
		createShellArgs, 				/* CX^X */
		OneChild, 						/* qEBWFbg̎ */
		ShellWidget,					/* i */
		hasFamily, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		hasNormalChild, 				/* EBWFbg\֐ */
		shellCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Intrinsic.h>\n"
		"#include <X11/StringDefs.h>", 	/* CN[hEt@C */
		"ApplicationShell", 			/* NX */
		"applicationShellWidgetClass",	/* ϐiNXE|C^j */
		&applicationShellWidgetClass,	/* NXϐiNXE|C^j */
		createApplication, 				/* CX^XtH[}bg */
		createApplicationArgs, 			/* CX^X */
		OneChild, 						/* qEBWFbg̎ */
		ShellWidget,					/* i */
		hasChild, 						/* č\\֐ */
		hasNoFamily, 					/* c[\쐬\֐ */
		hasNormalChild, 				/* EBWFbg\֐ */
		shellCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Shell.h>", 		/* CN[hEt@C */
		"TransientShell", 				/* NX */
		"transientShellWidgetClass",	/* ϐiNXE|C^j */
		&transientShellWidgetClass,		/* NXϐiNXE|C^j */
		createShell, 					/* CX^XtH[}bg */
		createShellArgs, 				/* CX^X */
		OneChild, 						/* qEBWFbg̎ */
		ShellWidget,					/* i */
		hasFamily, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		hasNormalChild, 				/* EBWFbg\֐ */
		shellCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Simple.h>",  /* CN[hEt@C */
		"Simple", 						/* NX */
		"simpleWidgetClass",			/* ϐiNXE|C^j */
		&simpleWidgetClass,				/* NXϐiNXE|C^j */
		NULL, 							/* CX^XtH[}bg */
		NULL, 							/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		NULL, 							/* č\\֐ */
		NULL, 							/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		NULL							/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Grip.h>",  	/* CN[hEt@C */
		"Grip", 						/* NX */
		"gripWidgetClass",				/* ϐiNXE|C^j */
		&gripWidgetClass,				/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Label.h>",  	/* CN[hEt@C */
		"Label", 						/* NX */
		"labelWidgetClass",				/* ϐiNXE|C^j */
		&labelWidgetClass,				/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Command.h>", /* CN[hEt@C */
		"Command", 						/* NX */
		"commandWidgetClass",			/* ϐiNXE|C^j */
		&commandWidgetClass,			/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/MenuButton.h>",  /* CN[hEt@C */
		"MenuButton", 					/* NX */
		"menuButtonWidgetClass",		/* ϐiNXE|C^j */
		&menuButtonWidgetClass,			/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Repeater.h>",/* CN[hEt@C */
		"Repeater", 					/* NX */
		"repeaterWidgetClass",			/* ϐiNXE|C^j */
		&repeaterWidgetClass,			/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Toggle.h>",  /* CN[hEt@C */
		"Toggle", 						/* NX */
		"toggleWidgetClass",			/* ϐiNXE|C^j */
		&toggleWidgetClass,				/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/List.h>",  	/* CN[hEt@C */
		"List", 						/* NX */
		"listWidgetClass",				/* ϐiNXE|C^j */
		&listWidgetClass,				/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Panner.h>",  /* CN[hEt@C */
		"Panner", 						/* NX */
		"pannerWidgetClass",			/* ϐiNXE|C^j */
		&pannerWidgetClass,				/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Scrollbar.h>",	/* CN[hEt@C */
		"Scrollbar", 					/* NX */
		"scrollbarWidgetClass",			/* ϐiNXE|C^j */
		&scrollbarWidgetClass,			/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/StripChart.h>", 	/* CN[hEt@C */
		"StripChart", 					/* NX */
		"stripChartWidgetClass",		/* ϐiNXE|C^j */
		&stripChartWidgetClass,			/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/AsciiText.h>\n"
		"#include <X11/Xaw/Text.h>\n"
		"#include <X11/Xaw/TextSrc.h>\n"
		"#include <X11/Xaw/TextSink.h>\n"
		"#include <X11/Xaw/AsciiSrc.h>\n"
		"#include <X11/Xaw/AsciiSink.h>\n",  /* CN[hEt@C */
		"Text", 						/* NX */
		"asciiTextWidgetClass",			/* ϐiNXE|C^j */
		&asciiTextWidgetClass,			/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		NormalWidget,					/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/Sme.h>",  	/* CN[hEt@C */
		"Sme", 							/* NX */
		"smeObjectClass",				/* ϐiNXE|C^j */
		&smeObjectClass,				/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		SmeObject,						/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/SmeBSB.h>",  /* CN[hEt@C */
		"SmeBSB", 						/* NX */
		"smeBSBObjectClass",			/* ϐiNXE|C^j */
		&smeBSBObjectClass,				/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		SmeObject,						/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}, {
		"#include <X11/Xaw/SmeLine.h>", /* CN[hEt@C */
		"SmeLine", 						/* NX */
		"smeLineObjectClass",			/* ϐiNXE|C^j */
		&smeLineObjectClass,			/* NXϐiNXE|C^j */
		createNormal, 					/* CX^XtH[}bg */
		createNormalArgs, 				/* CX^X */
		NoChild, 						/* qEBWFbg̎ */
		SmeObject,						/* i */
		hasParent, 						/* č\\֐ */
		partsExist, 					/* c[\쐬\֐ */
		NULL, 							/* EBWFbg\֐ */
		widgetCreater 					/* i쐬֐ */
	}
};

/***************************************************************************
 *	PartsAllocFiǗp̃mۂ܂
 *	`
 *		PartsTree *PartsAlloc(void);
 *	Ԃl
 *		NULL:		G[isj
 *		NULLȊO:	蓖Ăꂽ
 *	
 ***************************************************************************/
PartsTree *PartsAlloc(void)
{
	PartsTree *alloc_ptr;
	
	alloc_ptr = (PartsTree*)XtMalloc(sizeof(PartsTree));
	if(alloc_ptr != NULL) {
		alloc_ptr->widgetName   = NULL;
		alloc_ptr->variableName = NULL;
		alloc_ptr->className    = NULL;
		alloc_ptr->partsWidget  = NULL;
		alloc_ptr->treeWidget   = NULL;
		alloc_ptr->mapping      = EOF;
		alloc_ptr->athenaInfo   = NULL;
		alloc_ptr->parent_ptr   = NULL;
		alloc_ptr->child_ptr    = NULL;
		alloc_ptr->prev_ptr     = NULL;
		alloc_ptr->next_ptr     = NULL;
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	PartsFreeFiǗp̃܂
 *	`
 *		void PartsFree(PartsTree *release_ptr);
 *	Ԃl
 *		NULL:		G[isj
 *		NULLȊO:	蓖Ăꂽ
 *	
 ***************************************************************************/
void PartsFree(PartsTree *release_ptr)
{
	if(release_ptr != NULL) {
		if(release_ptr->partsWidget != NULL) {
			XtDestroyWidget(release_ptr->partsWidget);
		}
		if(release_ptr->treeWidget != NULL) {
			XtDestroyWidget(release_ptr->treeWidget);
		}
		if(release_ptr->widgetName != NULL) {
			XtFree(release_ptr->widgetName);
		}
		if(release_ptr->variableName != NULL) {
			XtFree(release_ptr->variableName);
		}
		if(release_ptr->className != NULL) {
			XtFree(release_ptr->className);
		}
		XtFree((char*)release_ptr);
	}
}

/***************************************************************************
 *	partsUnlinkFc[畔iJiANj
 *	`
 *		PartsTree *partsUnlink(PartsTree *parts);
 *	
 *		PartsTree *parts;	AN镔i
 *	Ԃl
 *		NULLȊO	ANi
 *	
 *		
 *	oO
 *		@Z̕iƎq̕i̗ɑ݂ꍇ́AAN
 *		܂B
 *		@{Iɂ́Aq珇ɊJĂB
 ***************************************************************************/
PartsTree *partsUnlink(PartsTree *parts)
{
	if(parts != NULL) {
		if(parts->parent_ptr != NULL && 
					parts->prev_ptr == NULL && parts->next_ptr == NULL) {
			parts->parent_ptr->child_ptr = parts->child_ptr;
		} else {
			if(parts->child_ptr == NULL) {
				if(parts->prev_ptr != NULL) {
					parts->prev_ptr->next_ptr = NULL;
				}
				if(parts->next_ptr != NULL) {
					parts->next_ptr->prev_ptr = NULL;
				}
			} else {
				fprintf(stderr, "%s:%d:partsUnlink() error. "
					"Can't Unlink!! / "
					"This parts has child & brother(s).\n", 
					__FILE__, __LINE__);
				abort();
			}
		}
		parts->parent_ptr = NULL;
	}
	return(parts);
}

/***************************************************************************
 *	partsUnlinkAndFreeFc[畔iJiANj^
 *	`
 *		void partsUnlinkAndFree(PartsTree *parts);
 *	
 *		PartsTree *parts;	AN^镔i
 *	
 *		
 *	oO
 *		@Z̕iƎq̕i̗ɑ݂ꍇ́AAN
 *		܂B
 *		@{Iɂ́Aq珇ɊJĂB
 ***************************************************************************/
void partsUnlinkAndFree(PartsTree *parts)
{
	PartsFree(partsUnlink(parts));
}

/***************************************************************************
 *	PartsTopTraceFGUIp[c̃c[\g[X
 *	`
 *		void PartsTopTrace(PartsTree *parts, 
 *									void (*PartsProc)(PartsTree *parts));
 *	
 *		PartsTree *parts;	
 *		void (*PartsProc)(PartsTree *parts);
 *	
 *	
 ***************************************************************************/
void PartsTopTrace(PartsTree *parts, void (*PartsProc)(PartsTree *parts))
{
	if(parts != NULL) {
		if(PartsProc != NULL) {
			PartsProc(parts);
		}
		if(parts->child_ptr != NULL) {
			PartsTopTrace(parts->child_ptr, PartsProc);
		}
		if(parts->next_ptr != NULL) {
			PartsTopTrace(parts->next_ptr, PartsProc);
		}
	}
}

/***************************************************************************
 *	PartsBottomTraceFGUIp[c̃c[\g[X
 *	`
 *		void PartsBottomTrace(PartsTree *parts, 
 *									void (*PartsProc)(PartsTree *parts));
 *	
 *		PartsTree *parts;	
 *		void (*PartsProc)(PartsTree *parts);
 *	
 *	
 ***************************************************************************/
void PartsBottomTrace(PartsTree *parts, void (*PartsProc)(PartsTree *parts))
{
	if(parts != NULL) {
		if(parts->child_ptr != NULL) {
			PartsBottomTrace(parts->child_ptr, PartsProc);
		}
		if(parts->next_ptr != NULL) {
			PartsBottomTrace(parts->next_ptr, PartsProc);
		}
		if(PartsProc != NULL) {
			PartsProc(parts);
		}
	}
}

/***************************************************************************
 *	PartsSumFGUIp[c̃c[\g[X炩̍vl߂
 *	`
 *		void PartsSum(PartsTree *parts, 
 *									int (*PartsProc)(PartsTree *parts));
 *	
 *		PartsTree *parts;	
 *		void (*PartsProc)(PartsTree *parts);
 *	
 *	
 ***************************************************************************/
int PartsSum(PartsTree *parts, int (*PartsProc)(PartsTree *parts))
{
	int sum = 0;

	if(PartsProc != NULL) {
		sum += PartsProc(parts);
	}
	if(parts->child_ptr != NULL) {
		sum += PartsSum(parts->child_ptr, PartsProc);
	}
	if(parts->next_ptr != NULL) {
		sum += PartsSum(parts->next_ptr, PartsProc);
	}
	return(sum);
}

/***************************************************************************
 *	PartsSearchFGUIp[c̃c[\g[X
 *	`
 *		void PartsSearch(PartsTree *parts, 
 *									int (*PartsProc)(PartsTree *parts));
 *	
 *		PartsTree *parts;	
 *		void (*PartsProc)(PartsTree *parts);
 *	
 *	
 ***************************************************************************/
XtPointer PartsSearch(PartsTree *parts, XtPointer (*PartsProc)(PartsTree *parts))
{
	XtPointer target = NULL;

	if(PartsProc != NULL) {
		target = PartsProc(parts);
	}
	if(parts->child_ptr != NULL && target == NULL) {
		target = PartsSearch(parts->child_ptr, PartsProc);
	}
	if(parts->next_ptr != NULL && target == NULL) {
		target = PartsSearch(parts->next_ptr, PartsProc);
	}
	return(target);
}

/***************************************************************************
 *	PartsTopTrace2FGUIp[c̃c[\g[X
 *	`
 *		void PartsTopTrace2(PartsTree *parts, 
 *									void (*PartsProc)(PartsTree *parts));
 *	
 *		PartsTree *parts;	
 *		void (*PartsProc)(PartsTree *parts);
 *	
 *	
 ***************************************************************************/
void PartsTopTrace2(PartsTree *parts, XtPointer client_data, 
				void (*PartsProc)(PartsTree *parts, XtPointer client_data))
{
	if(PartsProc != NULL) {
		PartsProc(parts, client_data);
	}
	if(parts->child_ptr != NULL) {
		PartsTopTrace2(parts->child_ptr, client_data, PartsProc);
	}
	if(parts->next_ptr != NULL) {
		PartsTopTrace2(parts->next_ptr, client_data, PartsProc);
	}
}

/***************************************************************************
 *	PartsTopDownTraceFGUIp[c̃c[\g[X
 *	`
 *		void PartsTopDownTrace(PartsTree *parts, 
 *									Boolean (*PartsProc)(PartsTree *parts));
 *	
 *		PartsTree *parts;	
 *		Boolean (*PartsProc)(PartsTree *parts);
 *	
 *	
 ***************************************************************************/
void PartsTopDownTrace(PartsTree *parts, Boolean (*PartsProc)(PartsTree *parts))
{
	Boolean realizedFlag = True;

	if(parts != NULL) {
		if(PartsProc != NULL) {
			realizedFlag = PartsProc(parts);
		}
		if(realizedFlag == FALSE && parts->child_ptr != NULL) {
			PartsTopDownTrace(parts->child_ptr, PartsProc);
		}
		if(parts->next_ptr != NULL) {
			PartsTopDownTrace(parts->next_ptr, PartsProc);
		}
	}
}

/***************************************************************************
 *	isPartsF
 *	`
 *		int isParts(PartsTree *parts);
 *	
 *		PartsTree *parts;	
 *	
 *	
 ***************************************************************************/
int isParts(PartsTree *parts)
{
	return((parts != NULL)?(parts->partsWidget != NULL):(FALSE));
}

/***************************************************************************
 *	whereIsPartsWidgetF
 *	`
 *		int whereIsPartsWidget(PartsTree *parts);
 *	
 *		PartsTree *parts;	
 *	
 *	
 ***************************************************************************/
XtPointer whereIsPartsWidget(PartsTree *parts)

{
	return((XtPointer)(parts != NULL)?(parts->partsWidget):(NULL));
}

/***************************************************************************
 *	whereIsTreeWidgetF
 *	`
 *		int whereIsTreeWidget(PartsTree *parts);
 *	
 *		PartsTree *parts;	
 *	
 *	
 ***************************************************************************/
XtPointer whereIsTreeWidget(PartsTree *parts)
{
	return((XtPointer)(parts != NULL)?(parts->treeWidget):(NULL));
}

/***************************************************************************
 *	youngestBrotherF
 *	`
 *		int youngestBrother(PartsTree *parts);
 *	
 *		PartsTree *parts;	
 *	
 *	
 ***************************************************************************/
PartsTree *youngestBrother(PartsTree *parts)
{
	if(parts != NULL) {
		while(parts->next_ptr != NULL)
			parts = parts->next_ptr;
	}
	return(parts);
}

/***************************************************************************
 *	connectToTailF
 *	`
 *		PartsTree **connectToTail(PartsTree **parts);
 *	
 *		PartsTree *parts;	
 *	
 *	
 ***************************************************************************/
PartsTree **connectToTail(PartsTree **parts)
{
	if(*parts != NULL) {
		while((*parts)->next_ptr != NULL)
			parts = &(*parts)->next_ptr;
	}
	return(parts);
}

/***************************************************************************
 *	partsPointerF
 *	`
 *		void partsPointer(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *	
 ***************************************************************************/
void partsPointer(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = (PartsTree*)client_data;
	PartsTree newParts;

	CurrentParts = parts;
	makableObject(parts);
}

/***************************************************************************
 *	partsChildLinkFc[ɕiAiNj
 *	`
 *		PartsTree *partsChildLink(PartsTree *node, PartsTree *newParts);
 *	
 *		PartsTree *node;		iǉʒuim[hj
 *		PartsTree *newParts;	iqƂājڑ镔i
 *	Ԃl
 *		NULL		G[
 *		NULLȊO	ǉꂽĩm[h
 *	
 *	
 ***************************************************************************/
PartsTree *partsChildLink(PartsTree *node, PartsTree *newParts)
{
	if(node != NULL && newParts != NULL) {
		if(node->child_ptr == NULL) {
			/*********************************************************
			 *	iǉm[hɎqEBWFbg݂Ȃꍇ
			 *********************************************************/
			node->child_ptr = newParts;
			newParts->parent_ptr = node;
		} else {
			/*******************************************************
			 *	iǉm[hɎqEBWFbg݂ꍇ
			 *******************************************************/
			newParts->parent_ptr = node;
			newParts->prev_ptr = youngestBrother(node->child_ptr);
			newParts->prev_ptr->next_ptr = newParts;
		}
	}
	return(node);
}

/***************************************************************************
 *	rootPartsFc[̍{Ԃ
 *	`
 *		PartsTree *rootParts(PartsTree *node);
 *	
 *		PartsTree *node;		i
 *	Ԃl
 *		NULL		G[
 *	
 *	
 ***************************************************************************/
PartsTree *rootParts(PartsTree *parts)
{
	while(parts->parent_ptr != NULL)
		parts = parts->parent_ptr;
	return(parts);
}

/***************************************************************************
 *	partsAppendFc[ɕiǉ
 *	`
 *		PartsTree *partsAppend(PartsTree *node, 
 *							const char *widgetName, AWidgetInfo *awInfo);
 *	
 *		PartsTree *node;		iǉʒuim[hj
 *		char *widgetName;		ǉ镔ĩEBWFbg
 *		AWidgetInfo *awInfo;	ǉ镔ȉ
 *	Ԃl
 *		NULL		sorG[
 *		NULLȊO	ǉĩm[h
 *	
 *	
 ***************************************************************************/
PartsTree *partsAppend(PartsTree *node, 
								const char *widgetName, AWidgetInfo *awInfo)
{
	PartsTree *newParts;
	extern Widget mguiTree;

	newParts = PartsAlloc();
	if(newParts != NULL) {
		newParts->widgetName = XtNewString(widgetName);
		newParts->athenaInfo = awInfo;
		newParts->treeWidget = 
				XtVaCreateManagedWidget(
						widgetName, 
						toggleWidgetClass, 
						mguiTree, 
						XtNtreeParent, 
								((node != NULL)?(node->treeWidget):(NULL)), 
						XtNlabel, newParts->widgetName,
						XtNradioData, newParts,
						NULL);
		if(node != NULL) {
			XawToggleChangeRadioGroup(newParts->treeWidget, node->treeWidget);
		}
		XtAddCallback(newParts->treeWidget, 
					XtNcallback, partsPointer, (XtPointer)newParts);
		XtRealizeWidget(newParts->treeWidget);
	}
	return(newParts);
}

/***************************************************************************
 *	partsAddF
 *	`
 *		void partsAdd(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *	
 ***************************************************************************/
void partsAdd(Widget w, XtPointer client_data, XtPointer call_data)
{
	char className[256];
	PartsTree **parts = (PartsTree**)client_data;
	PartsTree *newParts;
	XawListReturnStruct *awTarget;

	awTarget = XawListShowCurrent(mguiList);
	if(parts != NULL && awTarget->list_index != XAW_LIST_NONE) {
		newParts = partsAppend(*parts, currentWidgetName, 
							*(awidgetInfo + awTarget->list_index));
		if(*parts == NULL) {
			sprintf(className, "%c%s", toupper(*currentWidgetName), 
					currentWidgetName+(*currentWidgetName != '\0'));
			newParts->className = XtNewString(className);
			*parts = newParts;
		} else {
			(void)partsChildLink(*parts, newParts);
		}
		partsRenewal(*parts);
	}
}

/***************************************************************************
 *	partsDeleteF
 *	`
 *		void partsDelete(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *	
 ***************************************************************************/
void partsDeleteOne(PartsTree *parts)
{
	if(parts != NULL) {
		if(parts->prev_ptr == NULL) {
			if(parts->parent_ptr != NULL) {
				parts->parent_ptr->child_ptr = NULL;
			}
		} else {
			parts->prev_ptr->next_ptr = parts->next_ptr;
			if(parts->next_ptr != NULL) {
				parts->next_ptr->prev_ptr = parts->prev_ptr;
			}
		}
		XtDestroyWidget(parts->treeWidget);
		XtFree((char*)parts);
	}
}

/***************************************************************************
 *	partsDeleteF
 *	`
 *		void partsDelete(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *	
 ***************************************************************************/
void partsDelete(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree **parts = (PartsTree**)client_data;
	PartsTree *newParts;
	Widget parentTree;
	extern Widget mguiTree;

	if(parts != NULL) {
		if(*parts != NULL) {
			PartsBottomTrace((*parts)->child_ptr, partsDeleteOne);
			partsDeleteOne(*parts);
			*parts == NULL;
		}
	}
}

/***************************************************************************
 *	partsDeleteInMenuF
 *	`
 *		void partsDeleteInMenu(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *	
 ***************************************************************************/
void partsDeleteInMenu(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;

	partsDelete(w, parts, call_data);
}

/***************************************************************************
 *	PopupNamingDialog: fBXNEf[^o^p̃_CAÕ|bvAbv
 *	`
 *		void PopupNamingDialog(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopupNamingDialog(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget enterShell;
	Position x, y;
	Dimension width, height;
	
	enterShell = XtParent((Widget)client_data);
	/***********************************
	 *	Root Window ̍Wnɕϊ
	 ***********************************/
	XtTranslateCoords(XtParent(enterShell),		/* Widget */
						(Position) 0,			/* x */
						(Position) 0,			/* y */
						&x, &y);				/* coords on root window */

	/*******************************************************************
	 *	|bvAbvVF̈ʒu肷i܂AoĂȂj
	 *******************************************************************/
	XtVaSetValues(enterShell, XtNx, x, XtNy, y, NULL);

	XtPopup(enterShell, XtGrabExclusive);
}

/***************************************************************************
 *	NamingDialogSet: fBXNEf[^̓o^
 *	`
 *		void NamingDialogSet(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	Ԃl
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void NamingDialogSet(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget dialog = (Widget)client_data;

	/*****************************************************
	 *	_CAOEBWFbgœ͂擾
	 *****************************************************/
	currentWidgetName = XawDialogGetValueString(dialog);
	XtPopdown(XtParent(client_data));
	partsAdd(w, &CurrentParts, NULL);
}

/***************************************************************************
 *	NamingDialogPopdown: EBWFbg̖p̃EBhE|bv_E
 *	`
 *		void NamingDialogPopdown(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	Ԃl
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void NamingDialogPopdown(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget popdownWidget = (Widget)client_data;

	XtPopdown(XtParent(popdownWidget));
}

/***************************************************************************
 *	PopdownAncestorShell: EBWFbg̍ł߂c̃VF|bv_E
 *	`
 *		void PopdownAncestorShell(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	Ԃl
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopdownAncestorShell(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget popdownWidget = w;

	while(popdownWidget != NULL && XtIsShell(popdownWidget) == False)
		popdownWidget = XtParent(popdownWidget);

	XtPopdown(popdownWidget);
}

/***************************************************************************
 *	hasParent: eEBWFbg݂̑𒲂ׂ
 *	`
 *		Boolean hasParent(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;		
 *	Ԃl
 *		^:		eEBWFbg
 *		U:		eEBWFbg݂Ȃ
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean hasParent(AWidgetInfo *myWidget, PartsTree *parts)
{
	Boolean result = FALSE;

#ifdef	DEBUG
	printf("hasParent<");
#endif	/*DEBUG*/
	if(parts != NULL) {
		result = (parts->parent_ptr != NULL);
#ifdef	OLD_IMPREMENT
		result = ((parts->parent_ptr != NULL)?
						(parts->parent_ptr->partsWidget != NULL):(False));
#endif	/*OLD_IMPREMENT*/
#ifdef	DEBUG
		printf("(%s)", parts->widgetName);	fflush(stdout);
#endif	/*DEBUG*/
	}
#ifdef	DEBUG
	printf("=%d>", result);	fflush(stdout);
#endif	/*DEBUG*/
	return(result);
}

/***************************************************************************
 *	hasChild: qEBWFbg݂̑𒲂ׂ
 *	`
 *		Boolean hasChild(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;		
 *	Ԃl
 *		^:		qEBWFbg
 *		U:		qEBWFbg݂Ȃ
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean hasChild(AWidgetInfo *myWidget, PartsTree *parts)
{
	Boolean result = FALSE;

#ifdef	DEBUG
	printf("hasChild<");
#endif	/*DEBUG*/
	if(parts != NULL) {
		if((parts->child_ptr != NULL)?
				(parts->child_ptr->athenaInfo != NULL):(False)) {
			result = parts->child_ptr->athenaInfo->remakable(
										parts->child_ptr->athenaInfo, 
														parts->child_ptr);
		}
#ifdef	DEBUG
		printf("(%s)", parts->widgetName);	fflush(stdout);
#endif	/*DEBUG*/
	}
#ifdef	DEBUG
	printf("=%d>", result);	fflush(stdout);
#endif	/*DEBUG*/
	return(result);
}

/***************************************************************************
 *	hasFamily: e^qEBWFbg݂̑𒲂ׂ
 *	`
 *		Boolean hasFamily(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;		
 *	Ԃl
 *		^:		e^qEBWFbg
 *		U:		e^qEBWFbg݂Ȃ
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean hasFamily(AWidgetInfo *myWidget, PartsTree *parts)
{
	Boolean result = FALSE;

#ifdef	DEBUG
	printf("hasFamily<");
#endif	/*DEBUG*/
	if(parts != NULL) {
		result = (parts->parent_ptr != NULL) &&
				((parts->child_ptr != NULL && parts->child_ptr->athenaInfo != NULL)?
					(parts->child_ptr->athenaInfo->remakable(
							parts->child_ptr->athenaInfo, parts->child_ptr)):(False));
#ifdef	DEBUG
		printf("(%s)", parts->widgetName);	fflush(stdout);
#endif	/*DEBUG*/
	}
#ifdef	DEBUG
	printf("=%d>", result);	fflush(stdout);
#endif	/*DEBUG*/
	return(result);
}

/***************************************************************************
 *	hasNoFamily: e^qEBWFbg݂̑𒲂ׂ
 *	`
 *		Boolean hasNoFamily(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;		
 *	Ԃl
 *		^:		e^qEBWFbg݂Ȃ
 *		U:		e^qEBWFbg
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean hasNoFamily(AWidgetInfo *myWidget, PartsTree *parts)
{
	return(parts == NULL);
}

/***************************************************************************
 *	hasNormalChild: ʂ̎qEBWFbg݂̑𒲂ׂ
 *	`
 *		Boolean hasNormalChild(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;		
 *	Ԃl
 *		^:		qEBWFbg
 *		U:		qEBWFbg݂Ȃ
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean hasNormalChild(AWidgetInfo *myWidget, PartsTree *parts)
{
	Boolean result = FALSE;
	PartsTree *parts_ptr;

	if(parts != NULL) {
		for(parts_ptr = parts->child_ptr;
					parts_ptr != NULL;parts_ptr = parts_ptr->next_ptr) {
			if(parts_ptr->athenaInfo != NULL) {
				result = 
					result || (parts_ptr->athenaInfo->type & NormalWidget);
			}
		}
	}
	return(result);
}

/***************************************************************************
 *	partsExist: IĂp[c݂̑𒲂ׂ
 *	`
 *		Boolean partsExist(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;		
 *	Ԃl
 *		^:		IĂEBWFbg
 *		U:		IĂEBWFbg݂Ȃ
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean partsExist(AWidgetInfo *myWidget, PartsTree *parts)
{
	return(parts != NULL);
}

/***************************************************************************
 *	alwaysMakable: ɃEBWFbg쐬\ȂƂԂ֐
 *	`
 *		Boolean alwaysMakable(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;		
 *	Ԃl
 *		ɐ^		iEBWFbg쐬\j
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean alwaysMakable(AWidgetInfo *myWidget, PartsTree *parts)
{
	return(True);
}

/***************************************************************************
 *	alwaysDismakable: ɃEBWFbg쐬s\ȂƂԂ֐
 *	`
 *		Boolean alwaysDismakable(struct _AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;		
 *	Ԃl
 *		ɋU		iEBWFbg쐬s\j
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean alwaysDismakable(AWidgetInfo *myWidget, PartsTree *parts)
{
	return(False);
}

/***************************************************************************
 *	widgetCreation: ʂ̃EBWFbg
 *	`
 *		void widgetCreation(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;		
 *	Ԃl
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void widgetCreater(AWidgetInfo *myWidget, PartsTree *parts)
{
	if(parts != NULL) {
		if(parts->parent_ptr == NULL) {
			printf("No parent!!\n");
#ifdef	DEBUG
		} else {
			printf("%s:%d:%s's parent is \"%s-", __FILE__, __LINE__, 
					parts->widgetName, parts->parent_ptr->widgetName);
			fflush(stdout);
			printf("-%s\".\n", 
				((parts->parent_ptr->partsWidget != NULL)?
					(XtName(parts->parent_ptr->partsWidget)):("<<NULL>>")));
#endif	/*DEBUG*/
		}
#ifdef	DEBUG
		printf("%s:%d:XtVaCreateManagedWidget(\"%s\"); : -> Create", 
					__FILE__, __LINE__, parts->widgetName);
		fflush(stdout);
#endif	/*DEBUG*/
		parts->partsWidget = 
			XtVaCreateManagedWidget(
					parts->widgetName, 
					*myWidget->partsClass, 
					((parts->parent_ptr != NULL)?	\
						(parts->parent_ptr->partsWidget):(NULL)), NULL);
#ifdef	DEBUG
		printf("\"%s\"\n", XtName(parts->partsWidget));
		fflush(stdout);
#endif	/*DEBUG*/
#ifdef	OLD
		switch(parts->mapping) {
		case True:
			XtMapWidget(parts->partsWidget);
			break;
		case False:
			XtUnmapWidget(parts->partsWidget);
			break;
		case EOF:
			break;
		}
#endif	/*OLD*/
#ifdef	DEBUG
	} else {
		printf("%s:%d:%s's class is \"%s\" << pass >>\n", __FILE__, __LINE__, 
				parts->widgetName, parts->athenaInfo->className);
#endif	/*DEBUG*/
	}
}

/***************************************************************************
 *	shellCreater: Shell EBWFbg쐬
 *	`
 *		void shellCreater(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;		
 *	Ԃl
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void shellCreater(AWidgetInfo *myWidget, PartsTree *parts)
{
	if(parts != NULL) {
#ifdef	DEBUG
		printf("%s:%d:XtVaCreatePopupShell(\"%s\"); : -> Create", 
							__FILE__, __LINE__, parts->widgetName);
		fflush(stdout);
#endif	/*DEBUG*/
		if(parts->parent_ptr != NULL) {
			parts->partsWidget = 
				XtVaCreatePopupShell(
						parts->widgetName, 
						*myWidget->partsClass, 
						parts->parent_ptr->partsWidget, 
						NULL);
		} else {
			parts->partsWidget = 
				XtVaCreatePopupShell(
						parts->widgetName, 
						*myWidget->partsClass, 
						topLevel, 
						NULL);
		}
#ifdef	DEBUG
		printf("\"%s\"\n", XtName(parts->partsWidget));
		fflush(stdout);
#endif	/*DEBUG*/
#ifdef	OLD
		switch(parts->mapping) {
		case True:
			XtMapWidget(parts->partsWidget);
			break;
		case False:
			XtUnmapWidget(parts->partsWidget);
			break;
		case EOF:
			break;
		}
#endif	/*OLD*/
#ifdef	DEBUG
	} else {
		printf("%s:%d:%s's class is \"%s\" << pass >>\n", __FILE__, __LINE__, 
				parts->widgetName, parts->athenaInfo->className);
#endif	/*DEBUG*/
	}
}

/***************************************************************************
 *	partsMapping: EBWFbg̃}bv^A}bvݒ肷
 *	`
 *		void partsMapping(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;		
 *	Ԃl
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsMapping(PartsTree *parts)
{
	if(parts != NULL) {
		if((parts->partsWidget != NULL)?
					(XtIsRealized(parts->partsWidget)):(False)) {
			switch(parts->mapping) {
			case True:
#ifdef	DEBUG
				printf("%s:%d:XtMapWidget(\"%s\");\n", 
						__FILE__, __LINE__, XtName(parts->partsWidget));
#endif	/*DEBUG*/
				XtMapWidget(parts->partsWidget);
				break;
			case False:
#ifdef	DEBUG
				printf("%s:%d:XtUnmapWidget(\"%s\");\n", 
						__FILE__, __LINE__, XtName(parts->partsWidget));
#endif	/*DEBUG*/
				XtUnmapWidget(parts->partsWidget);
				break;
			case EOF:
				break;
			}
		}
#ifdef	OLD
	} else {
		printf("%s:%d:%s's class is \"%s\" << pass >>\n", __FILE__, __LINE__, 
				parts->widgetName, parts->athenaInfo->className);
#endif	/*OLD*/
	}
}

/***************************************************************************
 *	makableObject: 쐬\ȃEBWFbg̃Xg쐬
 *	`
 *		void makableObject(PartsTree *parts);
 *	
 *		PartsTree *parts;		IĂeEBWFbg
 *								iNULL Ȃďʂ̃EBWFbgj
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void makableObject(PartsTree *parts)
{
	int counter, limit, sum;
	static char *empty = "Empty";

	limit = sizeof(widgetSet)/sizeof(widgetSet[0]);
	if(widgetList == NULL) {
		widgetList  = (char**)malloc(sizeof(char*) * limit);
	}
	if(awidgetInfo == NULL) {
		awidgetInfo = (AWidgetInfo**)malloc(sizeof(AWidgetInfo*) * limit);
	}
	for(counter = 0;counter < limit;++counter) {
		*(widgetList  + counter) = NULL;
		*(awidgetInfo + counter) = NULL;
	}
	for(sum = 0, counter = 0;counter < limit;++counter) {
		if(widgetSet[counter].creatable != NULL) {
			if(widgetSet[counter].creatable(&widgetSet[counter], parts)) {
				*(widgetList  + sum) = (char*)widgetSet[counter].className;
				*(awidgetInfo + sum) = &widgetSet[counter];
				++sum;
			}
		}
	}
	if(sum == 0) {
		XawListChange(mguiList, &empty, 1, 0, True);
		XtSetSensitive(mguiList, False);
	} else {
		XawListChange(mguiList, widgetList, sum, 0, True);
		XtSetSensitive(mguiList, True);
	}
}

#ifdef	CREATE_SAMPLE
/***************************************************************************
 *	: 
 *	`
 *		void Creation(AWidgetInfo *myWidget, PartsTree *parts);
 *	
 *		AWidgetInfo *myWidget;	
 *		PartsTree *parts;		
 *	Ԃl
 *		
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void Creation(PartsTree *currentParts)
{
	parts->treeWidget = 
		XtVaCreateManagedWidget(
				currentWidgetName, 
				, 
				, 
				NULL);
	XtRealizeWidget(parts->treeWidget);
}
#endif	/*CREATE_SAMPLE*/

/***************************************************************************
 *	partsDestroyWidgetF
 *	`
 *		void partsDestroyWidget(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *	
 ***************************************************************************/
void partsDestroyWidget(PartsTree *parts)
{
	if(parts != NULL) {
		if(parts->partsWidget != NULL) {
#ifdef	DEBUG
			printf("%s:%d:XtDestroyWidget(\"%s\");\n", 
					__FILE__, __LINE__, XtName(parts->partsWidget));
#endif	/*DEBUG*/
			XtDestroyWidget(parts->partsWidget);
		}
		parts->partsWidget = NULL;
	}
}

/***************************************************************************
 *	partsCreateWidgetF
 *	`
 *		void partsCreateWidget(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *	
 ***************************************************************************/
void partsCreateWidget(PartsTree *parts)
{
	if((parts != NULL)?(parts->athenaInfo != NULL):(False)) {
#ifdef	DEBUG
		printf("\"%s\"-\"%s\"<<", 
						parts->widgetName, parts->athenaInfo->className);
		fflush(stdout);
#endif	/*DEBUG*/
		if(parts->athenaInfo->remakable != NULL) {
			if(parts->athenaInfo->remakable(parts->athenaInfo, parts)) {
#ifdef	DEBUG
				printf(":we will remake.>>\n");
#endif	/*DEBUG*/
				if(parts->athenaInfo->widgetCreation != NULL) {
					parts->athenaInfo->widgetCreation(
												parts->athenaInfo, parts);
				}
#ifdef	DEBUG
			} else {
				printf(": I can't remake.>>\n");
#endif	/*DEBUG*/
			}
#ifdef	DEBUG
		} else {
			printf("No Way to remake.>>\n");
#endif	/*DEBUG*/
		}
	}
}

/***************************************************************************
 *	partsRealizeF
 *	`
 *		Boolean partsRealize(PartsTree *parts);
 *	
 *		PartsTree *parts;	
 *	
 *	
 ***************************************************************************/
Boolean partsRealize(PartsTree *parts)
{
	Boolean realizableFlag = True;

	if(parts->athenaInfo->realizable != NULL) {
		realizableFlag = 
				parts->athenaInfo->realizable(parts->athenaInfo, parts);
	}
	if(realizableFlag && parts->partsWidget != NULL) {
		XtRealizeWidget(parts->partsWidget);
	}
	return(realizableFlag);
}

/***************************************************************************
 *	partsRenewalFi̍č\zs
 *	`
 *		void partsRenewal(PartsTree *parts);
 *	
 *		PartsTree *parts;
 *	
 *	
 ***************************************************************************/
void partsRenewal(PartsTree *parts)
{
	int counter, length;
	Boolean autoMapFlag;

	while(parts->parent_ptr != NULL)
		parts = parts->parent_ptr;

	if(parts != NULL) {
#ifdef	DEBUG
		printf("\n~-_-~   ~-_-~   ~-_-~   ~-_-~   ~-_-~   ~\n");fflush(stdout);
		length = printf("> Widget Tree of \"%s\"\n", parts->widgetName);
		for(counter = 0;counter < length;++counter)
			printf("~");
		printf("\n");
#endif	/*DEBUG*/
		PartsBottomTrace(parts->child_ptr, partsDestroyWidget);
		partsDestroyWidget(parts);
	
		partsCreateWidget(parts);
		PartsTopTrace(parts->child_ptr, partsCreateWidget);
		if(parts->partsWidget != NULL) {
#ifdef	OLD
			XtVaGetValues(parts->partsWidget, 
					XtNmappedWhenManaged, &autoMapFlag, NULL);
#endif	/*OLD*/
			PartsTopDownTrace(parts, partsRealize);
			PartsBottomTrace(parts, partsMapping);
		}
#ifdef	DEBUG
		printf("_-~-_   _-~-_   _-~-_   _-~-_   _-~-_   _\n\n");fflush(stdout);
#endif	/*DEBUG*/
	}
}

/***************************************************************************
 *	partsMapFEBWFbg}bv
 *	`
 *		void partsMap(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *	
 ***************************************************************************/
void partsMap(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;

	if(parts != NULL) {
		parts->mapping = True;
		if((parts->partsWidget != NULL)?
					(XtIsRealized(parts->partsWidget)):(False)) {
			XtMapWidget(parts->partsWidget);
		}
	}
}

/***************************************************************************
 *	partsUnmapFEBWFbgA}bv
 *	`
 *		void partsUnmap(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *	
 ***************************************************************************/
void partsUnmap(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;

	if(parts != NULL) {
		parts->mapping = False;
		if((parts->partsWidget != NULL)?
					(XtIsRealized(parts->partsWidget)):(False)) {
			XtUnmapWidget(parts->partsWidget);
		}
	}
}

/***************************************************************************
 *	partsMapAutoF}bv邩ǂ́AEBWFbgɔC
 *	`
 *		void partsMapAuto(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *	
 ***************************************************************************/
void partsMapAuto(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;

	if(parts != NULL) {
		parts->mapping = EOF;
	}
}

/***************************************************************************
 *	partsPopup: w肳ꂽVFi|bvAbv
 *	`
 *		void partsPopup(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsPopup(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget popupShell;
	Position x, y;
	Dimension width, height;
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	
	popupShell = parts->partsWidget;
	if(popupShell != NULL && XtIsShell(popupShell)) {
		/***********************************
		 *	Root Window ̍Wnɕϊ
		 ***********************************/
		XtTranslateCoords(XtParent(popupShell),		/* Widget */
							(Position) 0,			/* x */
							(Position) 0,			/* y */
							&x, &y);				/* coords on root window */
		/*******************************************************************
		 *	|bvAbvVF̈ʒu肷i܂AoĂȂj
		 *******************************************************************/
		XtVaSetValues(popupShell, XtNx, x, XtNy, y, NULL);

		XtPopup(popupShell, XtGrabNone);
#ifdef	DEBUG
	} else {
		printf("partsPopup():Widget=%p,XtIsRealized()=%d,XtIsShell()=%d\n", 
				popupShell, XtIsRealized(popupShell), XtIsShell(popupShell));
#endif	/*DEBUG*/
	}
}

/***************************************************************************
 *	partsPopdown: w肳ꂽVFi|bv_E
 *	`
 *		void partsPopdown(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsPopdown(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget popdownShell;
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	
	popdownShell = parts->partsWidget;
	if(popdownShell != NULL && 
			XtIsRealized(popdownShell) && XtIsShell(popdownShell)) {
		XtPopdown(popdownShell);
	}
}

/***************************************************************************
 *	saveFileLineFt@CɂPsۑ
 *	`
 *		void saveFileLine(const char *string);
 *	
 *		const char *string;		t@Cɕۑ镶
 *	
 *		@
 ***************************************************************************/
void saveFileLine(const char *string)
{
	fprintf(save_fp, "%s\n", string);
}

/***************************************************************************
 *	copyBufferLineFRs[obt@ɂPsۑ
 *	`
 *		void copyBufferLine(const char *string);
 *	
 *		const char *string;		Rs[obt@ɕۑ镶
 *	
 *		@
 ***************************************************************************/
void copyBufferLine(const char *string)
{
	copyBufferList = stringConnect(copyBufferList, stringsAlloc(string));
}

/***************************************************************************
 *	treeListFiP̕ic[t@C֊i[
 *	`
 *		void treeList(PartsTree *parts);
 *	
 *		PartsTree *parts;	t@C֊i[镔i
 *	
 *		@̊֐́AiP̕ic[t@C֊i[邽߂
 *		֐łB
 *		@̊֐ PartsTopTrace() ȉ̂悤ɂƁA
 *		
 *		    PartsTopTrace(partsRoot, treeList);   
 *		      partsRoot c ic[̍@@ 
 *		      treeList  c ̊֐@@@@@@ 
 *		
 *		ic[ŜۑłB
 ***************************************************************************/
void treeList(PartsTree *parts, XtPointer client_data)
{
	int counter;
	int length = 0;
	char stringBuffer[1024];
	PartsTree *parts_ptr;
	void (*saveLineProc)(const char *string) = (void (*)())client_data;

	for(counter = 0, parts_ptr = parts;parts_ptr->parent_ptr != NULL;
							parts_ptr = parts_ptr->parent_ptr, ++counter) {
		length += sprintf(stringBuffer+length, "\t");
	}
	if(counter == 0) {
		length += sprintf(stringBuffer+length, "%c%s  %s", 
			toupper(*parts->widgetName), 
			parts->widgetName+(*parts->widgetName != '\0'), parts->widgetName);
	} else {
		length += sprintf(stringBuffer+length, "%s  %s", 
							parts->athenaInfo->className, parts->widgetName);
	}
	switch(parts->mapping) {
	case True:
		length += sprintf(stringBuffer+length, "  [map]");
		break;
	case False:
		length += sprintf(stringBuffer+length, "  [unmap]");
		break;
	case EOF:
		break;
	}
	saveLineProc(stringBuffer);
}

/***************************************************************************
 *	partsTreeSave: ic[ۑ
 *	`
 *		void partsTreeSave(PartsTree *parts, FILE *fp)
 *	
 *		PartsTree *parts;		ic[̍
 *		FILE *fp;				ۑt@C̃t@C|C^
 *	
 *		
 ***************************************************************************/
void partsTreeSave(PartsTree *parts, FILE *fp)
{
	save_fp = fp;
	while(parts->parent_ptr != NULL)
		parts = parts->parent_ptr;
	
	PartsTopTrace2(parts, (XtPointer)saveFileLine, treeList);
}

/***************************************************************************
 *	partsTreeCopy: ic[Rs[obt@ɕۑ
 *	`
 *		void partsTreeCopy(PartsTree *parts, FILE *fp)
 *	
 *		PartsTree *parts;		ic[̍
 *		FILE *fp;				ۑt@C̃t@C|C^
 *	
 *		
 ***************************************************************************/
void partsTreeCopy(PartsTree *parts)
{
	stringRelease(copyBufferList);
	copyBufferList = NULL;
	PartsTopTrace2(parts, (XtPointer)copyBufferLine, treeList);
}

/***************************************************************************
 *	searchClassNameFNXNXɂĂ̏擾
 *	`
 *		AWidgetInfo *searchClassName(const char *className);
 *	
 *		const char *className;		NX
 *	Ԃl
 *		NULL:		YNX񂪌Ȃ
 *		NULLȊO:	ꂽNX
 *	
 *		
 ***************************************************************************/
AWidgetInfo *searchClassName(const char *className)
{
	int counter;
	int limit;
	AWidgetInfo *result_ptr;

	limit = sizeof(widgetSet)/sizeof(widgetSet[0]);
	for(counter = 0, result_ptr = NULL;
					counter < limit && result_ptr == NULL;++counter) {
		if(strcmp(widgetSet[counter].className, className) == 0) {
			result_ptr = &widgetSet[counter];
		}
	}
	return(result_ptr);
}

/***************************************************************************
 *	youngestInLevelFw肳ꂽΓIȐeq֌WňԎႢiT
 *	`
 *		PartsTree *youngestInLevel(PartsTree *nodeParts, int relativeLevel);
 *	
 *		PartsTree *nodeParts;	
 *		int relativeLevel;		eq֌Wie̎qj
 *	Ԃl
 *		NULL:		w肳ꂽΓIȐeq֌WłȂ
 *		NULLȊO:	w肳ꂽΓIȐeq֌WňԎႢiԂ
 *	
 *	
 ***************************************************************************/
PartsTree *youngestInLevel(PartsTree *nodeParts, int relativeLevel)
{
	int exitFlag;
	int level = 0;
	PartsTree *youngestParts = NULL;

	if(relativeLevel >= 0) {
		youngestParts = nodeParts;
		do {
			exitFlag = TRUE;
			youngestParts = youngestBrother(youngestParts);
			if(youngestParts->child_ptr != NULL) {
				if(level < relativeLevel) {
					level++;
					youngestParts = youngestParts->child_ptr;
					exitFlag = FALSE;
				}
			}
		} while(exitFlag == FALSE);
	}
	
	return((relativeLevel == level)?(youngestParts):(NULL));
}

/***************************************************************************
 *	getTreeListFif[^t@Csǂݍ
 *	`
 *		PartsTree *getTreeList(PartsTree *parts, FILE *fp);
 *	
 *		PartsTree *parts;	ic[̍
 *		FILE *fp;			t@C|C^
 *	Ԃl
 *		NULL:		G[isj
 *		NULLȊO:	쐬if[^
 *	
 *	
 ***************************************************************************/
PartsTree *getTreeList(PartsTree *parts, const char *line_ptr)
{
	int newLevel;
	char *indent_ptr;
	char className[20], widgetName[50];
	PartsTree *parts_ptr, *node;
	PartsTree *newParts = NULL;
	AWidgetInfo *classInfo;

	if(line_ptr != NULL) {
		for(newLevel = 0;*line_ptr == '\t';++newLevel, ++line_ptr)
			;						/* s */
		sscanf(line_ptr, "%19s%49s", className, widgetName);
#ifdef	DEBUG
		printf("%s [%s] -- %d\n", widgetName, className, newLevel);
#endif	/*DEBUG*/
		
		classInfo = searchClassName(className);
		if(classInfo == NULL && newLevel == 0) {
			classInfo = searchClassName("ApplicationShell");
			readAppdefaultFile(className);
		}
		if((classInfo != NULL)?(classInfo->instance != NULL):(False)) {
			node = youngestInLevel(parts, newLevel - 1);
			newParts = partsAppend(node, widgetName, classInfo);
			if(newLevel > 0) {
				(void)partsChildLink(node, newParts);
			} else {
				newParts->className = XtNewString(className);
			}
		}
	}
	return(newParts);
}

/***************************************************************************
 *	partsTreeLoadFic[ǂݍ
 *	`
 *		void partsTreeLoad(PartsTree **parts_ptr_ptr, FILE *fp);
 *	
 *		PartsTree **parts_ptr_ptr;	
 *		FILE *fp;					
 *	
 *	
 ***************************************************************************/
void partsTreeLoad(PartsTree **parts_ptr_ptr, FILE *fp)
{
	PartsTree *parts = NULL;
	PartsTree *newParts;
	char lineBuffer[4096], *line_ptr;
	
	save_fp = fp;
	if(parts_ptr_ptr != NULL) {
		if(*parts_ptr_ptr != NULL) {
			parts = *parts_ptr_ptr;
			while(parts->parent_ptr != NULL)
				parts = parts->parent_ptr;
		}
		PartsBottomTrace(parts, partsUnlinkAndFree);
		parts = *parts_ptr_ptr = NULL;
		while(feof(fp) == 0 && ferror(fp) == 0) {
			line_ptr = fgets(lineBuffer, sizeof(lineBuffer), fp);
			/*printf("%s\n", line_ptr);*/
			newParts = getTreeList(parts, line_ptr);
			if(newParts != NULL) {
				if(*parts_ptr_ptr == NULL) {
					*parts_ptr_ptr = parts = newParts;
				}
			}
		}
		if(parts != NULL) {
			partsRenewal(parts);
		}
	}
}
 
/***************************************************************************
 *	partsTreePasteFic[ǂݍ
 *	`
 *		void partsTreePaste(PartsTree **parts_ptr_ptr, FILE *fp);
 *	
 *		PartsTree **parts_ptr_ptr;	
 *		FILE *fp;					
 *	
 *	
 ***************************************************************************/
void partsTreePaste(PartsTree **parts_ptr_ptr, String pasteBuffer)
{
	PartsTree *parts = NULL;
	PartsTree *newParts;
	StringsLink *strings, *string_ptr;
	
	strings = stringsAlloc(pasteBuffer);
	if(parts_ptr_ptr != NULL) {
		if(*parts_ptr_ptr != NULL) {
			parts = *parts_ptr_ptr;
			while(parts->parent_ptr != NULL)
				parts = parts->parent_ptr;
		}
		PartsBottomTrace(parts, partsUnlinkAndFree);
		parts = *parts_ptr_ptr = NULL;
		for(string_ptr = strings;string_ptr != NULL;
									string_ptr = string_ptr->next_ptr) {
			newParts = getTreeList(parts, string_ptr->string);
			if(newParts != NULL) {
				if(*parts_ptr_ptr == NULL) {
					*parts_ptr_ptr = parts = newParts;
				}
			}
		}
		if(parts != NULL) {
			partsRenewal(parts);
		}
	}
	stringRelease(strings);
}
 
/***************************************************************************
 *	noArgFwȂx]쐬p̊֐
 *	`
 *		char *noArg(PartsTree *parts);
 *	
 *		PartsTree *parts;		iigpj
 *	Ԃl
 *		ɁA󕶎ւ̃|C^
 *	
 *		@wȂx]Y쐬p̊֐
 *		w̏I[opxɑΉ邽߂̂Aۂ
 *		͖gpƓɂȂB
 ***************************************************************************/
char *noArg(PartsTree *parts)
{
	return("");
}

/***************************************************************************
 *	argWidgetFwEBWFbgϐx]쐬p̊֐
 *	`
 *		char *argWidget(PartsTree *parts);
 *	
 *		PartsTree *parts;		i
 *	Ԃl
 *		EBWFbgϐ
 *	
 *	
 ***************************************************************************/
char *argWidget(PartsTree *parts)
{
	return(parts->widgetName);
}

/***************************************************************************
 *	argWidgetNameFwEBWFbgx]쐬p̊֐
 *	`
 *		char *argWidgetName(PartsTree *parts);
 *	
 *		PartsTree *parts;		i
 *	Ԃl
 *		NULL:		G[
 *		NULLȊO:	EBWFbg
 *	
 *	
 ***************************************************************************/
char *argWidgetName(PartsTree *parts)
{
	char *widgetName = "";

	if(parts != NULL) {
		widgetName = parts->widgetName;
	};
	return(widgetName);
}

/***************************************************************************
 *	argWidgetClassFwNXϐx]쐬p̊֐
 *	`
 *		char *argWidgetClass(PartsTree *parts);
 *	
 *		PartsTree *parts;		i
 *	Ԃl
 *	
 *	
 ***************************************************************************/
char *argWidgetClass(PartsTree *parts)
{
	const char *className = "";

	if(parts != NULL) {
		if(parts->athenaInfo != NULL) {
			if(parts->athenaInfo->variableName != NULL) {
				className = parts->athenaInfo->variableName;
			}
		}
	}
	return((char*)className);
}

/***************************************************************************
 *	argClassNameFwNXx]쐬p̊֐
 *	`
 *		char *argClassName(PartsTree *parts);
 *	
 *		PartsTree *parts;		i
 *	Ԃl
 *	
 *		wNXx́AƂẮAg\͂ȂB
 *		́Ac[ECWFbg쐬pɎgB
 ***************************************************************************/
char *argClassName(PartsTree *parts)
{
	const char *className = "";

	if(parts != NULL) {
		if(parts->className != NULL) {
			className = parts->className;
		} else {
			if(parts->athenaInfo != NULL) {
				if(parts->athenaInfo->className != NULL) {
					className = parts->athenaInfo->className;
				}
			}
		}
	}
	return((char*)className);
}

/***************************************************************************
 *	argParentFweEBWFbgϐx]쐬p̊֐
 *	`
 *		char *argParent(PartsTree *parts);
 *	
 *		PartsTree *parts;		i
 *	Ԃl
 *	
 *	
 ***************************************************************************/
char *argParent(PartsTree *parts)
{
	char *parent = "";

	if(parts != NULL) {
		if(parts->parent_ptr != NULL) {
			parent = argWidgetName(parts->parent_ptr);
		}
	}
	return(parent);
}

/***************************************************************************
 *	argWidgetClassFwNXϐx쐬p̊֐
 *	`
 *		char *argWidgetClass(PartsTree *parts);
 *	
 *		PartsTree *parts;		i
 *	Ԃl
 *	
 *	
 ***************************************************************************/
char *widgetAndClassName(PartsTree *parts)
{
	char *widgetName, *className;
	static char names[40];

	widgetName = argWidgetName(parts);
	className  = argClassName(parts);
	sprintf(names, "%s/%s", widgetName, className);
	return(names);
}

/***************************************************************************
 *	argAppContextFwAvP[VReNXgϐx]쐬p̊֐
 *	`
 *		char *argAppContext(PartsTree *parts);
 *	
 *		PartsTree *parts;		i
 *	Ԃl
 *		ɁA"app_context" 
 *	
 *	
 ***************************************************************************/
char *argAppContext(PartsTree *parts)
{
	return("app_context");
}

/***************************************************************************
 *	argApplicationClassFwAvP[VNXx]쐬p̊֐
 *	`
 *		char *argApplicationClass(PartsTree *parts);
 *	
 *		PartsTree *parts;		i
 *	Ԃl
 *		
 *	
 *		@AvP[VNX𖼕t[ɏ]č쐬B
 *	
 ***************************************************************************/
char *argApplicationClass(PartsTree *parts)
{
	static char className[40];

	/* ic[̍ */
	while(parts->parent_ptr != NULL)
		parts = parts->parent_ptr;
	
	if(parts != NULL) {
		sprintf(className, "%c%s", toupper(*parts->widgetName), 
				parts->widgetName+(*parts->widgetName != '\0'));
	}
	return(className);
}

/***************************************************************************
 *	argDummyClassNameFwV~[VpNX̃NXx]쐬p̊֐
 *	`
 *		char *argDummyClassName(PartsTree *parts);
 *	
 *		PartsTree *parts;		i
 *	Ԃl
 *	
 *		wV~[VpNX|C^̃NXx]쐬p̊֐
 *		wNXx́AƂẮAg\͂ȂB
 *		́Ac[ECWFbg쐬pɎgB
 ***************************************************************************/
char *argDummyClassName(PartsTree *parts)
{
	const char *className = "";

	if(parts != NULL && parts->athenaInfo != NULL && 
								parts->athenaInfo->partsClass != NULL) {
		className = parts->athenaInfo->className;
		if(strcmp(className, "ApplicationShell") == 0) {
			className = "TopLevelShell";	/* ApplicationShellO */
		}
	}
	return((char*)className);
}

/***************************************************************************
 *	stringAlloc: Ps̃mۂ
 *	`
 *		StringsLink *stringAlloc(const char *string);
 *	
 *		const char *string;		mۂʒus̃Ɋi[镶
 *	Ԃl
 *		NULL		s
 *		NULLȊO	蓖Ăꂽ
 *	
 *		@Ps̃mۂB
 *		
 ***************************************************************************/
StringsLink *stringAlloc(const char *string)
{
	StringsLink *alloc_ptr = NULL;
	
	alloc_ptr = (StringsLink*)XtMalloc(sizeof(StringsLink));
	if(alloc_ptr != NULL) {
		if(string != NULL) {
			alloc_ptr->string = XtNewString(string);
		} else {
			alloc_ptr->string = NULL;
		}
		alloc_ptr->next_ptr = NULL;
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	stringFree: p̃
 *	`
 *		void stringFree(StringsLink *lyric);
 *	Ԃl
 *		StringsLink *lyric;		镶񃊃NXgXg̃
 *	
 *		@
 ***************************************************************************/
void stringFree(StringsLink *release_ptr)
{
	if(release_ptr != NULL) {
#ifdef	DEBUG
		printf("%s\n", release_ptr->string);
#endif	/*DEBUG*/
		XtFree(release_ptr->string);
		XtFree((char*)release_ptr);
	}
}

/***************************************************************************
 *	stringRelease: p̃
 *	`
 *		void stringRelease(StringsLink *string);
 *	Ԃl
 *		StringsLink *string;	镶񃊃NXgXg̃
 *	
 *		@
 ***************************************************************************/
void stringRelease(StringsLink *string)
{
	StringsLink *release_ptr;
	
	while(string != NULL) {
		release_ptr = string;
		string = string->next_ptr;
		stringFree(release_ptr);
	}
}

/***************************************************************************
 *	stringsAlloc: Psȏ̃mۂ
 *	`
 *		StringsLink *stringsAlloc(const char *string);
 *	
 *		const char *string;		mۂʒus̃Ɋi[镶
 *	Ԃl
 *		NULL		s
 *		NULLȊO	蓖Ăꂽ
 *	
 *		@Ps̃mۂB
 *		
 ***************************************************************************/
StringsLink *stringsAlloc(const char *string)
{
	int length;
	int loopExit = True;
	const char *line_ptr, *line_end_ptr;
	StringsLink *alloc_ptr = NULL, *allocTop;

	line_ptr = string;
	allocTop = alloc_ptr = stringAlloc(NULL);
	do {
		loopExit = True;
		line_end_ptr = strchr(line_ptr, '\n');
		length = ((line_end_ptr != NULL)?
							(line_end_ptr-line_ptr):(strlen(line_ptr)));
		alloc_ptr->string = (char*)XtMalloc(length+1);
		if(alloc_ptr->string != NULL) {
			sprintf(alloc_ptr->string, "%.*s", length, line_ptr);
#ifdef	DEBUG
			printf("%s\n", alloc_ptr->string);	fflush(stdout);
#endif	/*DEBUG*/
			alloc_ptr->next_ptr = stringAlloc(NULL);
		}
		if(line_end_ptr != NULL && alloc_ptr->next_ptr != NULL) {
			line_ptr = line_end_ptr + (*line_end_ptr == '\n');
			alloc_ptr = alloc_ptr->next_ptr;
			loopExit = False;
		}
	} while(loopExit == False);
	XtFree((char*)alloc_ptr->next_ptr);
	alloc_ptr->next_ptr = NULL;
	return(allocTop);
}

/***************************************************************************
 *	stringConnect: 񃊃Ñ
 *	`
 *		StringsLink *stringConnect(StringsLink *strings1, 
 *										StringsLink *strings2);
 *	
 *		StringsLink *strings1;
 *		StringsLink *strings2;
 *	Ԃl
 *		񃊃N̐擪
 *	
 *		@
 ***************************************************************************/
StringsLink *stringConnect(StringsLink *strings1, StringsLink *strings2)
{
	StringsLink *string_ptr;

	if(strings1 != NULL) {
		string_ptr = strings1;
		while(string_ptr->next_ptr != NULL) {
			string_ptr = string_ptr->next_ptr;
		}
		string_ptr->next_ptr = strings2;
	} else {
		strings1 = strings2;
	}
	return(strings1);
}

/***************************************************************************
 *	partsCollectionF쐬EBWFbg̎ʏ쐬
 *	`
 *		void partsCollection(PartsTree *parts, XtPointer client_data);
 *	
 *		PartsTree *parts;
 *		XtPointer client_data;
 *	
 *		@쐬EBWFbg̎ʏ쐬܂B
 *		@́ApubNECN[hEt@C̐錾̂߂ɕKvB
 ***************************************************************************/
void partsCollection(PartsTree *parts, XtPointer client_data)
{
	int partsId;
	int *classArray = (int*)client_data;

	if(parts->athenaInfo != NULL) {
		partsId = parts->athenaInfo->id;
#ifdef	DEBUG
		printf("%s %s[%d]\n", 
				parts->athenaInfo->className, parts->widgetName, partsId);
#endif	/*DEBUG*/
		*(classArray+partsId) = True;
	}
}

/***************************************************************************
 *	partsIncludeFpubNECN[hEt@C̐錾쐬
 *	`
 *		void partsInclude(PartsTree *parts, XtPointer client_data);
 *	
 *		PartsTree *parts;		쐬镔ȉ
 *		XtPointer client_data;	쐬镔i̎ʏ
 *	
 *	
 ***************************************************************************/
void partsInclude(PartsTree *parts, XtPointer client_data)
{
	int partsId;
	int *classArray = (int*)client_data;

	if(parts->athenaInfo != NULL) {
		partsId = parts->athenaInfo->id;
		if(*(classArray+partsId)) {
			sourceList = stringConnect(sourceList, 
						stringsAlloc(parts->athenaInfo->publicInclude));
			*(classArray+partsId) = False;
		}
	}
}

/***************************************************************************
 *	partsVariableFEBWFbgɕKvȕϐ錾
 *	`
 *		void partsVariable(PartsTree *parts, XtPointer client_data);
 *	
 *		PartsTree *parts;		쐬镔ȉ
 *		XtPointer client_data;	ϐ錾̍s̕
 *	
 *		@
 *	
 ***************************************************************************/
void partsVariable(PartsTree *parts, XtPointer client_data)
{
	int length;
	char *variable_ptr;
	char *variableDefinition = (char*)client_data;

	length = strlen(variableDefinition);
	variable_ptr = variableDefinition + length;
	if((strlen(variableDefinition) + length) > 60) {
		sprintf(variable_ptr, "%s %s;", 
				((length == 0)?("\tWidget"):("")), parts->widgetName);
		/*printf("%s\n", variableDefinition);*/
		sourceList = 
				stringConnect(sourceList, stringsAlloc(variableDefinition));
		*variableDefinition = '\0';
	} else {
		sprintf(variable_ptr, "%s %s,", 
				((length == 0)?("\tWidget"):("")), parts->widgetName);
	}
}

/***************************************************************************
 *	partsCoding: Widget ɊւătH[}bgƈR[fBO
 *	`
 *		void partsCoding(PartsTree *parts, 
 *								const char *format, int *argumentsInfo);
 *	
 *		PartsTree *parts;	쐬 Widget Ɋւ
 *		const char *format;	tH[}bgisprintf() ̂́j
 *		int *argumentsInfo;	Lz
 *	
 *		Widget ɊւătH[}bgƈ񂩂R[fBO
 *	
 ***************************************************************************/
void partsCoding(PartsTree *parts, const char *format, int *argumentsInfo)
{
	int counter;
	int argumentType;
	char *arguments[10];
	char stringBuffer[1024];

	/*******************************
	 *	֐̈
	 *******************************/
	for(counter = 0;counter < 10;++counter)
		arguments[counter] = "";

	/*************************
	 *	֐̈쐬
	 *************************/
	if(parts != NULL && format != NULL && argumentsInfo != NULL) {
		for(counter = 0;*(argumentsInfo+counter) != NoArg;++counter) {
			argumentType = *(argumentsInfo+counter);
			/*printf("argument#%d's type = %d.\n", counter, argumentType);*/
			if(argumentType > NoArg && argumentType < VariableTypeNum) {
				arguments[counter] = argumentArrayProc[argumentType](parts);
			}
		}
		/****************************************
		 *	Widget ̍쐬R[fBO
		 ****************************************/
		sprintf(stringBuffer, format, arguments[0], arguments[1], 
				arguments[2], arguments[3], arguments[4], arguments[5], 
				arguments[6], arguments[7], arguments[8], arguments[9]);
		sourceList = stringConnect(sourceList, stringsAlloc(stringBuffer));
	}
}

/***************************************************************************
 *	partsCreateCoding: Widget 쐬R[fBO
 *	`
 *		void partsCreateCoding(PartsTree *parts);
 *	
 *		PartsTree *parts;	쐬 Widget Ɋւ
 *	
 *	
 ***************************************************************************/
void partsCreateCoding(PartsTree *parts)
{
	if(parts != NULL && parts->athenaInfo != NULL && 
							parts->athenaInfo->argTypes != NULL) {
		partsCoding(parts, 
				parts->athenaInfo->instance, parts->athenaInfo->argTypes);
	}
}

/***************************************************************************
 *	stringsLinkLength: 񃊃NXgXg̕JEg
 *	`
 *		int stringsLinkLength(StringsLink *strings);
 *	Ԃl
 *		񃊃NXgXg̕
 *	
 *		@
 ***************************************************************************/
int stringsLinkLength(StringsLink *strings)
{
	int counter;
	
	counter = 0;
	while(strings != NULL) {
		counter += strlen(strings->string) + 1;
		strings = strings->next_ptr;
	}
	return(counter);
}

/***************************************************************************
 *	stringsLink2string: 񃊃N𕶎ɕϊ
 *	`
 *		String stringsLink2string(StringsLink *strings);
 *	
 *		StringsLink *strings;
 *	Ԃl
 *		NULL:		G[isj
 *		NULLȊO:	ϊꂽ
 *	
 *		@
 ***************************************************************************/
String stringsLink2string(StringsLink *strings)
{
	int counter;
	size_t length;
	String textString;
	
	length = stringsLinkLength(strings);
	textString = XtMalloc(length + 1);
	for(counter = 0, *textString = '\0';strings != NULL && 
			(counter+strlen(strings->string)+1) <= length;
			counter+=strlen(strings->string)+1, strings=strings->next_ptr) {
		strcat(textString, strings->string);
		if(strings->next_ptr != NULL)
			strcat(textString, "\n");
	}
	return(textString);
}

/***************************************************************************
 *	makeSourceFb̃\[Xt@C쐬
 *	`
 *		void makeSource(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;					gp
 *		XtPointer client_data;		i
 *		XtPointer call_data;		gp
 *	
 *	
 ***************************************************************************/
void makeSource(Widget w, XtPointer client_data, XtPointer call_data)
{
	int counter;		/* [vJE^ */
	int numOfClass;		/* NXEBWFbgi[ϐ */
	int length;			/*  */
	int *classArray;	/* NXʂŎgp̗L𒲂ׂ邽߂̔z */
	int argumentsInfo[] = {ArgWidget, NoArg};	/* XtRealize() ̈ */
	char stringBuffer[80];	/* obt@ */
	PartsTree *parts = 		/* i */
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	extern Widget mguiSourceShell, mguiSourceArea, mguiSourceTools;
	extern Widget mguiPopdown, mguiSave, mguiLoad, mguiSourceFile, mguiSourceText;

	XtPopup(mguiSourceShell, XtGrabNonexclusive);
	while(parts->parent_ptr != NULL)
		parts = parts->parent_ptr;

	/***********************************************
	 *	pubNECN[ht@C̍쐬
	 ***********************************************/
	numOfClass = sizeof(widgetSet)/sizeof(widgetSet[0]);
	classArray = (int*)XtMalloc(sizeof(int) * numOfClass);
	if(classArray != NULL) {
		for(counter = 0;counter < numOfClass;++counter)
			*(classArray+counter) = False;
#ifdef	DEBUG
		printf("%s:%d:main();\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*DEBUG*/
		PartsTopTrace2(parts, (XtPointer)classArray, partsCollection);
#ifdef	DEBUG
		printf("%s:%d:main();\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*DEBUG*/
		PartsTopTrace2(parts, (XtPointer)classArray, partsInclude);
#ifdef	DEBUG
		printf("%s:%d:main();\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*DEBUG*/
		XtFree((char*)classArray);
#ifdef	DEBUG
		printf("%s:%d:main();\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*DEBUG*/
		sourceList = stringConnect(sourceList, 
					stringsAlloc("\nvoid main(int argc, char **argv)\n{"));
#ifdef	DEBUG
		printf("%s:%d:main();\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*DEBUG*/
		sourceList = stringConnect(sourceList, 
							stringsAlloc("\tXtAppContext app_context;"));
#ifdef	DEBUG
		printf("%s:%d:main();\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*DEBUG*/
		/*printf("\nvoid main(int argc, char **argv)\n{\n");*/
		/*printf("\tXtAppContext app_context;\n");*/
	}
	/**********************
	 *	Widget ϐ̒`
	 **********************/
	stringBuffer[0] = '\0';
#ifdef	DEBUG
	printf("%s:%d:main();\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*DEBUG*/
	PartsTopTrace2(parts, (XtPointer)stringBuffer, partsVariable);
#ifdef	DEBUG
	printf("%s:%d:main();\n", __FILE__, __LINE__);fflush(stdout);
#endif	/*DEBUG*/
	length = strlen(stringBuffer);
	if(length > 0) {
		sprintf(stringBuffer, "%.*s;\n", length-1, stringBuffer);
		sourceList = stringConnect(sourceList, stringsAlloc(stringBuffer));
	}
	/******************
	 *	Widget ̍\z
	 ******************/
	PartsTopTrace(parts, partsCreateCoding);
	/**********************
	 *	Widget ̎ԍ쐬
	 **********************/
	partsCoding(parts, "\tXtRealizeWidget(%s);", argumentsInfo);
	/*printf("\tXtAppMainLoop(app_context);\n}");*/
	sourceList = stringConnect(sourceList, 
					stringsAlloc("\tXtAppMainLoop(app_context);\n}\n"));
	XtVaSetValues(mguiSourceText, 
					XtNstring, stringsLink2string(sourceList), NULL);
	stringRelease(sourceList);
	sourceList = NULL;
}

/***************************************************************************
 *	widgetInitFwidgetSet ̎ʔԍ(ID)
 *	`
 *		void widgetInit(void);
 *	
 *	
 ***************************************************************************/
void widgetInit(void)
{
	int counter, numOfClass;

	/***********************************************
	 *	pubNECN[ht@C̍쐬
	 ***********************************************/
	numOfClass = sizeof(widgetSet)/sizeof(widgetSet[0]);
	for(counter = 0;counter < numOfClass;++counter) {
		widgetSet[counter].id = counter;
	}
}

/***************************************************************************
 *	partsLabelSet: c[iɎw肳ꂽ`Ńx𒣂t
 *	`
 *		void partsLabelSet(PartsTree *parts, XtPointer client_data);
 *	
 *		PartsTree *parts;
 *		XtPointer client_data;
 *	
 *		
 ***************************************************************************/
void partsLabelSet(PartsTree *parts, XtPointer client_data)
{
	char *(*argumentProc)(PartsTree *parts) = 
									(char *(*)(PartsTree *))client_data;

	XtVaSetValues(parts->treeWidget, XtNlabel, argumentProc(parts), NULL);
}

/***************************************************************************
 *	partsWidgetVariable: 
 *	`
 *		void partsWidgetVariable(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsWidgetVariable(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	
	PartsTopTrace2(rootParts(parts), (XtPointer)argWidget, partsLabelSet);
	XawTreeForceLayout(mguiTree);
}

/***************************************************************************
 *	partsWidgetName: 
 *	`
 *		void partsWidgetName(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsWidgetName(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	
	PartsTopTrace2(rootParts(parts), 
							(XtPointer)argWidgetName, partsLabelSet);
	XawTreeForceLayout(mguiTree);
}

/***************************************************************************
 *	partsClassNames: 
 *	`
 *		void partsClassNames(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsClassNames(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	
	PartsTopTrace2(rootParts(parts), 
							(XtPointer)argClassName, partsLabelSet);
	XawTreeForceLayout(mguiTree);
}

/***************************************************************************
 *	partsWidgetAndClassNames: 
 *	`
 *		void partsWidgetAndClassNames(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsWidgetAndClassNames(Widget w, 
							XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	
	PartsTopTrace2(rootParts(parts), 
						(XtPointer)widgetAndClassName, partsLabelSet);
	XawTreeForceLayout(mguiTree);
}

/***************************************************************************
 *	partsResourceBox: 
 *	`
 *		void partsResourceBox(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void partsResourceBox(Widget w, XtPointer client_data, XtPointer call_data)
{
	PartsTree *parts = 
			*(PartsTree **)((struct menu_data*)client_data)->client_data;
	
	makeResourceBox(parts);
}

/***************************************************************************
 *	createRenameShell: l[VF쐬܂
 *	`
 *		void createRenameShell(Widget parent);
 *	
 *		Widget parent;	
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
Widget createRenameShell(Widget parent)
{
	Widget renameShell, renameArea, renameBlock;
	Widget widgetname, widgetName, classname;
	Widget className, variablename, variableName;
	Widget renamePanel, renameSet, renamePopdown;

	renameShell = XtVaCreatePopupShell(
				"renameShell",
				transientShellWidgetClass,
				parent,
				NULL);

	renameArea = XtVaCreateManagedWidget(
				"renameArea",
				panedWidgetClass,
				renameShell,
				NULL);

	renameBlock = XtVaCreateManagedWidget(
				"renameBlock",
				formWidgetClass,
				renameArea,
				NULL);

	widgetname = XtVaCreateManagedWidget(
				"widgetname",
				labelWidgetClass,
				renameBlock,
				NULL);

	widgetName = XtVaCreateManagedWidget(
				"widgetName",
				asciiTextWidgetClass,
				renameBlock,
				NULL);

	classname = XtVaCreateManagedWidget(
				"classname",
				labelWidgetClass,
				renameBlock,
				NULL);

	className = XtVaCreateManagedWidget(
				"className",
				asciiTextWidgetClass,
				renameBlock,
				NULL);

	variablename = XtVaCreateManagedWidget(
				"variablename",
				labelWidgetClass,
				renameBlock,
				NULL);

	variableName = XtVaCreateManagedWidget(
				"variableName",
				asciiTextWidgetClass,
				renameBlock,
				NULL);

	renamePanel = XtVaCreateManagedWidget(
				"renamePanel",
				boxWidgetClass,
				renameArea,
				NULL);

	renameSet = XtVaCreateManagedWidget(
				"renameSet",
				commandWidgetClass,
				renamePanel,
				NULL);

	renamePopdown = XtVaCreateManagedWidget(
				"renamePopdown",
				commandWidgetClass,
				renamePanel,
				NULL);

	XtAddCallback(renamePopdown, XtNcallback, PopdownAncestorShell, NULL);
	return(renameShell);
}

