/***************************************************************************
 *	mwxcduty.c:  桼ƥƥ
 *	
 *		Date. 1997/09/15 -- 
 *			Programed by Nobuyuki Maruichi
 ***************************************************************************/

/***********************************************
 *	Ūʥ󥯥롼ɡե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <X11/Xlocale.h>
/*#include "mwxcd.h"*/
#include "stringuty.h"
#include "luty.h"

int JaLoacle = EOF;

MessageNode *FallbackDict = NULL;	/* ǥեȡå */
MessageNode *LocaleDict = NULL;		/* ϰ貽å */
MessageNode *EncodeDict = NULL;	/* ܸϰ貽󥳡ɼ༭ */

const char *encodeDicString = {
	"ja:ja_JP.eucJP\n"
	"ja_JP:ja_JP.eucJP\n"
	"ja_JP.ujis:ja_JP.eucJP\n"
	"ja_JP.eucJP:ja_JP.eucJP\n"
	"Jp_JP: ja_JP.eucJP\n"
	"ja_JP.AJEC:ja_JP.eucJP\n"
	"ja_JP.EUC:ja_JP.eucJP\n"
	"ja_JP.ISO-2022-JP:ja_JP.JIS7\n"
	"ja_JP.JIS:ja_JP.JIS7\n"
	"ja_JP.jis7:ja_JP.JIS7\n"
	"ja_JP.mscode:ja_JP.SJIS\n"
	"ja_JP.SJIS:ja_JP.SJIS\n"
	"japanese:ja_JP.eucJP\n"
	"japan:ja_JP.eucJP\n"
	"Japanese-EUC:ja_JP.eucJP"
};

int (*jcodesets[])(unsigned const char **src_ptr, int old, int *type) = 
								{codesetJis, codesetEuc, codesetSjis, NULL};
int (*jencodes[])(unsigned char *dest_ptr, int code, int old, int type) = 
								{encodeJis1, encodeEuc, encodeSjis, NULL};

/***************************************************************************
 *	keyword2mes: ɤϰ貽줿å
 *	
 *		const char *keyword2mes(const char *keyword);
 *	
 *		const char *keyword;
 *	֤
 *		ϰ貽줿å / ǥեȤΥå / 
 *	
 *		ɤϰ貽줿å롣˼Ԥȡ
 *		ǥեȤΥåޤϥɼȤ롣
 ***************************************************************************/
const char *keyword2mes(const char *keyword)
{
	const MessageNode *result = NULL;

	result = messageSearch(LocaleDict, keyword);
	if(result == NULL) {
		result = messageSearch(FallbackDict, keyword);
	}
	if(result == NULL) {
#ifdef	JA_DEBUG
		fprintf(stderr, "Keyword \"%s\" is not found.\n", keyword);
#endif	/*JA_DEBUG*/
	}
	return((result != NULL)?(result->message):(keyword));
}

/***************************************************************************
 *	jaEncodeType: ꤵƤܸΥ󥳡ɤμ̤ꤹ
 *	
 *		int jaEncodeType(void);
 *	
 *		ʤ
 *	֤
 *		NoJapanese(EOF):	ꤵƤ郎̤
 *		JaJIS(0):			JIS 
 *		JaEUC(1):			ܸ EUC 
 *		JaSJIS(2):			Shift-JIS 
 *	
 *		
 ***************************************************************************/
int jaEncodeType(void)
{
	int result;
	const MessageNode *encodeNode = NULL;
	const char *encodeNames[] = 
			{"ja_JP.JIS7", "ja_JP.eucJP", "ja_JP.SJIS", NULL};

#ifdef	JA_DEBUG
	printf("%s:%d:int jaEncodeType(void);\n", __FILE__, __LINE__);
#endif	/*JA_DEBUG*/
	if(EncodeDict == NULL) {
#ifdef	JA_DEBUG
		printf("%s:%d:int jaEncodeType(void);\n", __FILE__, __LINE__);
#endif	/*JA_DEBUG*/
		EncodeDict = makeMessages(NULL, encodeDicString);
	}
	encodeNode = messageSearch(EncodeDict, setlocale(LC_CTYPE, NULL));
	if(encodeNode != NULL) {
		result = searchInStringPointerArray(
									encodeNode->message, encodeNames, NULL);
	}
#ifdef	JA_DEBUG
	printf("%s:%d:int jaEncodeType(void);\n", __FILE__, __LINE__);
#endif	/*JA_DEBUG*/
	JaLoacle = result;
#ifdef	JA_DEBUG
	printf("%s:%d:%d = jaEncodeType(void);\n", __FILE__, __LINE__, result);
#endif	/*JA_DEBUG*/

	return(result);
}

/***************************************************************************
 *	jcodecnv: ܸ쥳ɤ鸽ߤɽѤܸ쥳ɤѴ
 *	
 *		char *jcodecnv(char *dest, size_t length, const char *src, int srcEncode);
 *	
 *		char *dest;			ɽѤܸ쥳ѴǼХåե
 *		size_t length;		ǼѥХåեΥ
 *		const char *src;	Υ󥳡ɤǳǼ줿ʸ
 *		int srcEncode;		Υ󥳡ɼ
 *	֤
 *		ߤɽѤܸ쥳ɤѴ줿ʸؤΥݥ
 *	
 *		ܸ쥳ɤ鸽ߤΥܸ쥳ɤѴ롣
 *		mwxcd Ǥϡ˰ʲΥޥѤƤޤ
 *		
 *		#define cdljc(string)   jcodecnv(NULL, 0, string, cdlFileEncode)
 *		
 *		嵭Τ褦 dest  NULL ꤹ뤳Ȥǽǡξ硢
 *		ΥХåեѴʸǼơΥݥ󥿤֤ޤ
 *		Хåե 4096 ХȤʤΤǡѴ̤ 4096 Х
 *		̤ǤʤƤϤʤʤ
 *	Х
 *		dest NULL ꤷƻȤ硢Хåե 4096 Х
 *		ۤ¾Υΰ˲뤳Ȥˤʤ뤿ᡢѴ̤ 4096 
 *		Х̤ǤʤƤϤʤʤѴ̤4096ХȤۤǽ
 *		ϡdest NULL ϤƤϤޤ
 *		JIS ɤؤѴȤʤĹץ󥹤ȯ뤿ᡢ
 *		Хˤʤ⤤ȤǧƤƲ
 *		JIS ɤξǰΩˤϡܤΥХåեɬפˤʤ
 *		ޤʿ
 *		
 ***************************************************************************/
char *jcodecnv(char *dest, size_t length, char *src, int srcEncode)
{
	int result;
	static char buffer[4096];
#ifdef	JA_DEBUG
	const char *encodeNames[] = {"NONE", "JIS", "EUC-JP", "S-JIS", NULL};
#endif	/*JA_DEBUG*/

	if(dest == NULL) {
		dest = buffer;
		length = sizeof(buffer);
	}
#ifdef	JA_DEBUG
	printf("%s:%d:jcodecnv();:SRC[%s] -> DEST[%s]\n", __FILE__, __LINE__, 
						encodeNames[srcEncode+1], encodeNames[JaLoacle+1]);
#endif	/*JA_DEBUG*/
	if(srcEncode >= 0 && JaLoacle >= 0) {
		result = string2otherCodeset(dest, length, src, 
								jcodesets[srcEncode], jencodes[JaLoacle]);
#ifdef	JA_DEBUG
		printf("jcodecnv(); %s\n", dest);
#endif	/*JA_DEBUG*/
	} else {
		dest = src;
	}
#ifdef	JA_DEBUG
	printf("%s:%d:jcodecnv();\n", __FILE__, __LINE__);
#endif	/*JA_DEBUG*/

	return(dest);
}

/***************************************************************************
 *	cnv2strlen: ʸ򸽺ߤ Locale ѴɬפʥХȿ
 *	
 *		int cnv2strlen(const char *src, int srcEncode);
 *	
 *		const char *src;	ʸ
 *		int srcEncode;		ʸΥɼ
 *	֤
 *		ߤ Locale ѴɬפʥХȿ
 *	
 *		
 *		
 ***************************************************************************/
int cnv2strlen(const char *src, int srcEncode)
{
	int result;

	if(srcEncode >= 0 && JaLoacle >= 0) {
		result = string2otherCodeset(NULL, 0, src, 
								jcodesets[srcEncode], jencodes[JaLoacle]);
	}
	return(result);
}

/***************************************************************************
 *	**strArray2jcnvAndNew: 
 *	
 *		char **strArray2jcnvAndNew(const char **src_ptr, 
 *										Int srcEncode, int destEncode);
 *	
 *		const char **src_ptr;
 *		int srcEncode;
 *		int destEncode;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
char **strArray2jcnvAndNew(const char **src_ptr, int srcEncode, int destEncode)
{
	char **result;

	if(srcEncode <= NoJapanese || srcEncode > JaSJIS) {
		srcEncode = JaSJIS;
	}
	if(destEncode <= NoJapanese || destEncode > JaSJIS) {
		destEncode = JaLoacle;
	}
	if(destEncode <= NoJapanese || destEncode > JaSJIS) {
		destEncode = JaSJIS;
	}
	result = strArray2cnvNewStrArray(src_ptr, 
							jcodesets[srcEncode], jencodes[destEncode]);
	return(result);
}

