/****************************************************************************
 *	utility.c: acconv ̃[eBeB֐
 *
 *			Date. 1996/01/06 -- 1996/01/06
 *				Programed by Nobuyuki Maruichi
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208 1983
 *			Tab Size 4 / Shift Width = 4
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>

/****************************************************
 *	X Toolkit/Athena Widget ̃CN[hEt@C
 ****************************************************/
#include <X11/Intrinsic.h>	/* Intrinsics Definitions */
#include <X11/StringDefs.h>	/* Standard Name-String definitions */
#include <X11/Core.h>
#include <X11/Shell.h>

#include <X11/Xatom.h>
#include <X11/Xmu/Atoms.h>

#include "WaveChart.h"

/***********************************************
 *	PCM Recorder/Player p̃wb_[Et@C
 ***********************************************/
#include "snd.h"
#include "ggxsnd.h"

/***************************************************************************
 *	O[oϐ
 *		TvO^C֌W
 *			MinuteSize: 	PԂ̃oCg
 *			SecondSize: 	PbԂ̃oCg
 *			CentiSecSize: 	P^POObԂ̃oCg
 *			currentSize: 	VKɊlƂ̔g`̃oCg
 *			unitSize: 		̊lP
 *			deltaSize: 		^Ԃ̕ύXP
 *			recTimeResizeCounter: 	^Ԃ̕ύXp̃JE^
 *		g`Ǘ֌W
 *			memoryListTop:	EXg̐擪
 ***************************************************************************/
extern long MinuteSize;
extern long SecondSize;
extern long CentiSecSize;
extern long currentSize;
extern long unitSize;
extern long deltaSize;
extern int recTimeResizeCounter;
WavesLink *currentWaves = NULL;

extern Atom AcTreeAtom;

typedef struct _WaveSelectionInfo {
	Atom type;						/* ZNVl̕\^܂ */
	XtPointer value;				/* ZNVl̊i[ꏊ */
	unsigned long length;			/* ZNVl̗vf̌ */
	int format;						/* ZNVl̗vf̑傫 */
} WaveSelectionInfo;
WaveSelectionInfo PasteInfo = {
	0, NULL, 0, 8
};

static void requestor_callback(Widget w, XtPointer client_data, 
				Atom *selection, Atom *type, 
				XtPointer value, unsigned long *length, int *format);
static void (*OnceAction_ptr)(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);
void SelectCopyOnce(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);
void SelectPasteOnce(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);
void SelectUnselectOnce(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);

static Boolean convert_proc(Widget w, Atom *selection, Atom *target,
				Atom *type_return, XtPointer *value_return, 
				unsigned long *length_return, int *format_return);
static void requestor_callback(Widget w, XtPointer client_data, 
				Atom *selection, Atom *type, 
				XtPointer value, unsigned long *length, int *format);


#ifdef	EXPERIMENT_IMPLEMENT
#endif	/*EXPERIMENT_IMPLEMENT*/
/***************************************************************************
 *	WavePaste: WaveChart EBWFbg selectPaste R[obN
 *	`
 *		void WavePaste(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		@WaveChart EBWFbg̔g`IɂƂȂg`f[^̕ϊs
 *		R[obN֐B
 ***************************************************************************/
void WavePaste(Widget w, XtPointer client_data, XtPointer call_data)
{
	int start_point, end_point;
	size_t size;
	int pastePos, pasteSize;
	int postWavePos;
	int reconnectType;
	WaveOrder *wavePrev, **waveMyself;
	WaveOrder *waveEnd, *wavePaste, *reconnectWave = NULL;
	WaveSearch searching, *searching_ptr;
	WaveSearch reconnectPos;
	XawWaveSelectionPaste *selectInfo = 
							(XawWaveSelectionPaste*)call_data;
	extern Widget pcmTitle;

#ifdef	SELECTION_DEBUG
	selectInfo->length /= unitSize;
	selectInfo->length *= unitSize;
	printf("%s(%d): WavePaste()--start.\n", __FILE__, __LINE__);
	printf("Paste: selection size %d : buffer %p : pastePos = %d\n", 
				selectInfo->length, selectInfo->value, selectInfo->pastePos);
#endif	/*SELECTION_DEBUG*/
	if(currentWaves != NULL) {
#ifdef	SELECTION_DEBUG
		printf("Paste: Original Wave Size %d [bytes] -- Encoding  "
					"Paste size %d [bytes]  Total %d [bytes]\n", 
					sizeOfWave(currentWaves->wave, getEncodingSizeUnit),
					selectInfo->length, selectInfo->length + 
					sizeOfWave(currentWaves->wave, getEncodingSizeUnit));
#endif	/*SELECTION_DEBUG*/
		/*******************************************************************
		 *	Og`ƃy[Xgg`
		 *******************************************************************/
		size = sizeOfWave(currentWaves->wave, getEncodingSizeUnit);
		pastePos = selectInfo->pastePos;
		if(pastePos < 0)
			pastePos = 0;
		if(pastePos > size)
			pastePos = size;
		searching_ptr = wave_search(currentWaves->wave, pastePos);
#ifdef	SELECTION_DEBUG
		if(searching_ptr != NULL) {
			printf("Paste: searching_ptr: wave[Pointer %p, Offser %d]\n",
				searching_ptr->wave_ptr, searching_ptr->offset);
			if(searching_ptr->wave_ptr != NULL) {
				printf("\tencoding size %d [bytes] recording size %d [bytes]\n" 
					"\twave size %d [bytes] pcm_wave[Pointer %p], \n" 
					"\t<<prev_ptr %p, next_ptr %p>>\n",
					searching_ptr->wave_ptr->encoding_size,
					searching_ptr->wave_ptr->recording_size,
					searching_ptr->wave_ptr->wave_size,
					searching_ptr->wave_ptr->pcm_wave,
					searching_ptr->wave_ptr->prev_ptr,
					searching_ptr->wave_ptr->next_ptr);
			}
		}
#endif	/*SELECTION_DEBUG*/
		if(searching_ptr == NULL) {
			waveEnd = lastWaveOrder(currentWaves->wave);
			searching.wave_ptr = NULL;
			searching.offset = 0;
			wavePrev = waveEnd->prev_ptr;
			if(waveEnd->encoding_size < unitSize) {
				reconnectPos.wave_ptr = waveEnd;
				reconnectPos.offset   = waveEnd->encoding_size;
			} else {
				reconnectPos = searching;
			}
		} else {
			reconnectPos = searching = (*searching_ptr);
			wavePrev = searching.wave_ptr->prev_ptr;
		}
#ifdef	SELECTION_DEBUG
		printf("Wave size %d [bytes], %d [offset]\n", size, searching.offset);
#endif	/*SELECTION_DEBUG*/
		waveMyself = ((wavePrev != NULL)?
					(&wavePrev->next_ptr):(&currentWaves->wave));
		pasteSize = selectInfo->length + searching.offset;
		wavePaste = WaveMemoryAlloc(pasteSize);
		*waveMyself = wavePaste;
		wavePaste->prev_ptr = wavePrev;
		memcpy(wavePaste->pcm_wave, 
					reconnectPos.wave_ptr->pcm_wave, reconnectPos.offset);
		setWave((unsigned char*)selectInfo->value, 
					wavePaste, reconnectPos.offset, selectInfo->length);
		(void)setRecordingSizes(wavePaste, getMemorySizeUnit);
		(void)setEncodingSizes( wavePaste, getRecordingSizeUnit);
		/*******************************************************************
		 *	㑤g`ƌ
		 *******************************************************************/
#ifdef	SELECTION_DEBUG
		printf("Paste: Wave Size %d [bytes] -- Encoding\n", 
				sizeOfWave(currentWaves->wave, getEncodingSizeUnit));
		printf("Paste: ^^^Test(pastePos + selectInfo->length) %d [bytes]\n", 
					pastePos + selectInfo->length);
#endif	/*SELECTION_DEBUG*/
		/*printf("㑤g`ƌ\n");*/
		if(searching.wave_ptr != NULL) {
			/*printf("g`\n");*/
			waveEnd = lastWaveOrder(currentWaves->wave);
			waveMyself = ((waveEnd->prev_ptr != NULL)?
						(&waveEnd->prev_ptr->next_ptr):(&currentWaves->wave));
#ifdef	SELECTION_DEBUG
			printf("waveEnd->encoding_size %d, searching.offset %d.\n", 
							waveEnd->encoding_size, searching.offset);
#endif	/*SELECTION_DEBUG*/
			reconnectType = -(waveEnd->encoding_size < searching.offset) 
				+(waveEnd->encoding_size > searching.offset) 
				+(waveEnd->encoding_size == unitSize && searching.offset == 0);
			switch(reconnectType) {
			default:
#ifdef	SELECTION_DEBUG
				printf("WavePaste(): ُȏԂł\n");
#endif	/*SELECTION_DEBUG*/
				break;
			case -1:	/* VɃmۂKvȂ */
				printf("VɃmۂKvȂ\n");
				memcpy(searching.wave_ptr->pcm_wave, 
							waveEnd->pcm_wave, waveEnd->encoding_size);
				postWavePos = waveEnd->encoding_size;
				*waveMyself = searching.wave_ptr;
				searching.wave_ptr->prev_ptr = waveEnd->prev_ptr;
				waveEnd->prev_ptr = NULL;
				releaseWaveMemory(waveEnd);
				printf("Paste: Wave Size %d [bytes] -- Delete %d [bytes]\n", 
						sizeOfWave(currentWaves->wave, getEncodingSizeUnit)
						, searching.offset - postWavePos);
#ifdef	SELECTION_DEBUG
			printf("Paste: searching_ptr: wave[Pointer %p, Offser %d]\n",
				searching.wave_ptr, searching.offset);
			if(searching.wave_ptr != NULL) {
				printf("\tencoding size %d [bytes] recording size %d [bytes]\n" 
					"\twave size %d [bytes] pcm_wave[Pointer %p], \n" 
					"\t<<prev_ptr %p, next_ptr %p>>\n",
					searching.wave_ptr->encoding_size,
					searching.wave_ptr->recording_size,
					searching.wave_ptr->wave_size,
					searching.wave_ptr->pcm_wave,
					searching.wave_ptr->prev_ptr,
					searching.wave_ptr->next_ptr);
			}
#endif	/*SELECTION_DEBUG*/
				reconnectWave = DeleteWave(searching.wave_ptr, postWavePos, 
								searching.offset - postWavePos);
#ifdef	SELECTION_DEBUG
			printf("Paste: searching_ptr: wave[Pointer %p]\n",
				reconnectWave);
			if(reconnectWave != NULL) {
				printf("\tencoding size %d [bytes] recording size %d [bytes]\n" 
					"\twave size %d [bytes] pcm_wave[Pointer %p], \n" 
					"\t<<prev_ptr %p, next_ptr %p>>\n",
					reconnectWave->encoding_size,
					reconnectWave->recording_size,
					reconnectWave->wave_size,
					reconnectWave->pcm_wave,
					reconnectWave->prev_ptr,
					reconnectWave->next_ptr);
			}
#endif	/*SELECTION_DEBUG*/
				if((reconnectWave != NULL)?
							(reconnectWave->prev_ptr == NULL):(False)) {
					currentWaves->wave = reconnectWave;
#ifdef	SELECTION_DEBUG
					printf("WavePaste(): g`̐擪ύX܂B\n");
#endif	/*SELECTION_DEBUG*/
				}
				(void)setRecordingSizes(reconnectWave, getMemorySizeUnit);
				(void)setEncodingSizes( reconnectWave, getRecordingSizeUnit);
				break;
			case 0:		/* TCYv */
#ifdef	SELECTION_DEBUG
				printf("TCYv\n");
#endif	/*SELECTION_DEBUG*/
				memcpy(searching.wave_ptr->pcm_wave, 
							waveEnd->pcm_wave, waveEnd->encoding_size);
				/* to be continued... */
			case 2:
#ifdef	SELECTION_DEBUG
				if(reconnectType == 2)
					printf("̂܂ܐڑ\n");
#endif	/*SELECTION_DEBUG*/
				*waveMyself = searching.wave_ptr;
				searching.wave_ptr->prev_ptr = waveEnd->prev_ptr;
				waveEnd->prev_ptr = NULL;
				releaseWaveMemory(waveEnd);
				break;
			case 1:		/* VɃmۂKv */
#ifdef	SELECTION_DEBUG
				printf("VɃmۂKv\n");
#endif	/*SELECTION_DEBUG*/
				searching.wave_ptr->prev_ptr = WaveUnitAlloc(unitSize);
				memcpy(searching.wave_ptr->prev_ptr->pcm_wave, 
							waveEnd->pcm_wave, waveEnd->encoding_size);
				postWavePos = waveEnd->encoding_size;
				searching.wave_ptr->prev_ptr->next_ptr = searching.wave_ptr;
				*waveMyself = searching.wave_ptr->prev_ptr;
				searching.wave_ptr->prev_ptr->prev_ptr = waveEnd->prev_ptr;
				waveEnd->prev_ptr = NULL;
				releaseWaveMemory(waveEnd);
				reconnectWave = 
					DeleteWave(searching.wave_ptr->prev_ptr, postWavePos, 
								searching.offset + unitSize - postWavePos);
				if((reconnectWave != NULL)?
							(reconnectWave->prev_ptr == NULL):(False)) {
					currentWaves->wave = reconnectWave;
				}
				(void)setRecordingSizes(reconnectWave, getMemorySizeUnit);
				(void)setEncodingSizes( reconnectWave, getRecordingSizeUnit);
				break;
			}
		}
		WaveRename(currentWaves);
		SetCurrentWaveName(currentWaves);
		makeMemoryList();
	} else {
		currentWaves = LinkedWaveAlloc(selectInfo->length);
		if(currentWaves != NULL) {
			setWave((unsigned char*)selectInfo->value, 
						currentWaves->wave, 0, selectInfo->length);
			(void)setRecordingSizes(currentWaves->wave, getMemorySizeUnit);
			(void)setEncodingSizes(currentWaves->wave, getRecordingSizeUnit);
			WaveRename(currentWaves);
			SetCurrentWaveName(currentWaves);
			makeMemoryList();
		}
	}
#ifdef	SELECTION_DEBUG
	printf("Paste: Wave Size %d [bytes] -- Encoding\n", 
				sizeOfWave(currentWaves->wave, getEncodingSizeUnit));
	printf("%s(%d): WavePaste()--end.\n", __FILE__, __LINE__);
#endif	/*SELECTION_DEBUG*/
}

/***************************************************************************
 *	WaveCut: WaveChart EBWFbg selectCut R[obN
 *	`
 *		void WaveCut(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		@WaveChart EBWFbg̔g`IɂƂȂg`f[^̕ϊs
 *		R[obN֐B
 ***************************************************************************/
void WaveCut(Widget w, XtPointer client_data, XtPointer call_data)
{
	char waveName[9];
	size_t size;
	struct snd_head newHeader;
	WaveOrder *reconnectWave = NULL;
	XawWaveSelectionArea *cutInfo = (XawWaveSelectionArea*)call_data;
	extern Widget pcmWave;
	extern Widget pcmTitle;
	extern WavesLink *memoryListTop;

	if(currentWaves != NULL) {
		/*******************************************************************
		 *	
		 *******************************************************************/
		size = sizeOfWave(currentWaves->wave, getEncodingSizeUnit);
#ifdef	SELECTION_DEBUG
		printf("Cut: Original Wave Size %d [bytes] -- Encoding  --> ", size);
#endif	/*SELECTION_DEBUG*/
		if(cutInfo->selectStart < 0)
			cutInfo->selectStart = 0;
		if(cutInfo->selectEnd > size)
			cutInfo->selectEnd = size;
		reconnectWave = DeleteWave(currentWaves->wave, cutInfo->selectStart, 
								cutInfo->selectEnd - cutInfo->selectStart);
		if((reconnectWave!=NULL)?(reconnectWave->prev_ptr==NULL):(True))
			currentWaves->wave = reconnectWave;
		size = sizeOfWave(currentWaves->wave, getEncodingSizeUnit);
#ifdef	SELECTION_DEBUG
		printf("Cut: New Wave Size %d [bytes]\n", size);
#endif	/*SELECTION_DEBUG*/
		if(size == 0) {
			if(currentWaves->prev_ptr == NULL) {
				/* N̐擪ꍇ */
				memoryListTop = currentWaves->next_ptr;
			}
			UnlinkWaves(currentWaves);
			FreeWaves(currentWaves);
			currentWaves = NULL;
			XawWaveAllClear(pcmWave);
		} else {
			sprintf(waveName, "%.8s", currentWaves->header.name);
			make_sndHeader(waveName, size, &newHeader);
			memcpy(&currentWaves->header, &newHeader, sizeof(newHeader));
		}
		WaveRename(currentWaves);
		SetCurrentWaveName(currentWaves);
		makeMemoryList();
	}
}

/***************************************************************************
 *	waveClearCall: WaveChart EBWFbg select-cut ANVďo
 *	`
 *		void waveClearCall(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		@
 ***************************************************************************/
void waveClearCall(Widget w, XtPointer client_data, XtPointer call_data)
{
	extern Widget pcmWave;

	XtCallActionProc(pcmWave, "select-clear", NULL, NULL, 0);
}

/***************************************************************************
 *	waveCutCall: 
 *	`
 *		void waveCutCall(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		@
 ***************************************************************************/
void waveCutCall(Widget w, XtPointer client_data, XtPointer call_data)
{
	extern Widget pcmWave;

#ifdef	SELECTION_DEBUG
	printf("Copy Menu: Cut!!\n");fflush(stdout);
#endif	/*SELECTION_DEBUG*/
	XtCallActionProc(pcmWave, "select-cut", NULL, NULL, 0);
	OnceAction_ptr = SelectCopyOnce;
}

/***************************************************************************
 *	waveCopyCall: 
 *	`
 *		void waveCopyCall(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		@
 ***************************************************************************/
void waveCopyCall(Widget w, XtPointer client_data, XtPointer call_data)
{
#ifdef	SELECTION_DEBUG
	printf("Copy Menu: Copy!!\n");fflush(stdout);
#endif	/*SELECTION_DEBUG*/
	
	OnceAction_ptr = SelectCopyOnce;
}

/***************************************************************************
 *	wavePasteCall: 
 *	`
 *		void wavePasteCall(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		@
 ***************************************************************************/
void wavePasteCall(Widget w, XtPointer client_data, XtPointer call_data)
{
#ifdef	SELECTION_DEBUG
	printf("Copy Menu: Paste!!\n");fflush(stdout);
#endif	/*SELECTION_DEBUG*/

	OnceAction_ptr = SelectPasteOnce;
}

/***************************************************************************
 *	waveUnselectCall: 
 *	`
 *		void waveUnselectCall(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	
 *		@
 ***************************************************************************/
void waveUnselectCall(Widget w, XtPointer client_data, XtPointer call_data)
{
#ifdef	SELECTION_DEBUG
	printf("Copy Menu: Unselect!!\n");fflush(stdout);
#endif	/*SELECTION_DEBUG*/

	OnceAction_ptr = SelectUnselectOnce;
}

/***************************************************************************
 *	OnceActionCall: w肳ꂽANVƓ`̊֐PAĂ
 *	`
 *		void OnceActionCall(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				EBWFbg
 *		XEvent *event;			Cxg
 *		String *params;			ANVւ̈Ƃĕϊe[uɋLq
 *								ꂽz
 *		Cardinal *num_params;	params ̕
 *	Ԃl
 *		Ȃ
 *	
 *		@W[O[oϐƂĎw肳ꂽ֐ւ̃|C^p
 *		āAANVƓ`̊֐ĂԁB
 *		
 ***************************************************************************/
/* ARGSUSED */
void OnceActionCall(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	if(OnceAction_ptr != NULL) {
		(*OnceAction_ptr)(w, event, params, num_params);
	}
	OnceAction_ptr = NULL;
}

/***************************************************************************
 *	SelectCopy: ANV
 *	`
 *		void SelectCopy(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				EBWFbg
 *		XEvent *event;			Cxg
 *		String *params;			gp
 *		Cardinal *num_params;	gp
 *	Ԃl
 *		Ȃ
 *	
 *		@
 *		
 ***************************************************************************/
/* ARGSUSED */
void SelectCopy(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	Time lastTime;
	extern struct menuData copyMenus;

	partsTreeCopy(PartsTree *parts);
	lastTime = XtLastTimestampProcessed(XtDisplay());
	if(XtOwnSelection(copyMenus.menu, XA_PRIMARY, lastTime, 
							convert_proc, NULL, NULL) == False) {
		XtWarning("Copy Menu: failed attempting to become "
				"selection owner; make a new selection.\n");
	}
}

/***************************************************************************
 *	SelectCopyOnce: ANV
 *	`
 *		void SelectCopyOnce(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				EBWFbg
 *		XEvent *event;			Cxg
 *		String *params;			gp
 *		Cardinal *num_params;	gp
 *	Ԃl
 *		Ȃ
 *	
 *		@
 *		
 ***************************************************************************/
/* ARGSUSED */
void SelectCopyOnce(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	Time lastTime;
	extern struct menuData copyMenus;

	lastTime = XtLastTimestampProcessed(XtDisplay(w));
	XtGetSelectionValue(copyMenus.menu, XA_PRIMARY, AcTreeAtom, 
							requestor_callback, event, lastTime);
	if(XtOwnSelection(copyMenus.menu, XA_PRIMARY, lastTime, 
							convert_proc, NULL, NULL) == False) {
		XtWarning("Copy Menu: failed attempting to become "
				"selection owner; make a new selection.\n");
	}
}

/***************************************************************************
 *	SelectPasteOnce: ANV
 *	`
 *		void SelectPasteOnce(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				EBWFbg
 *		XEvent *event;			Cxg
 *		String *params;			gp
 *		Cardinal *num_params;	gp
 *	Ԃl
 *		Ȃ
 *	
 *		@
 *		
 ***************************************************************************/
/* ARGSUSED */
void SelectPasteOnce(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	Time lastTime;
	extern Widget pcmWave;
	extern struct menuData copyMenus;

	lastTime = XtLastTimestampProcessed(XtDisplay(w));
	if(XtOwnSelection(copyMenus.menu, XA_PRIMARY, lastTime, 
							convert_proc, NULL, NULL) == False) {
		XtWarning("Copy Menu: failed attempting to become "
				"selection owner; make a new selection.\n");
	}
	XtCallActionProc(pcmWave, "select-paste", event, params, *num_params);
}

/***************************************************************************
 *	convert_proc: vꂽZNVf[^Ԃ֐
 *	`
 *		static Boolean convert_proc(Widget w, Atom *selection, Atom *target,
 *						Atom *type_return, XtPointer *value_return, 
 *						unsigned long *length_return, int *format_return);
 *	
 *	@
 *		Widget w;			ZNVLĂEBWFbg
 *		Atom *selection;	vꂽZNV̖OłAgw
 *		Atom *target;		ZNVɗv̌^w肵܂
 *								
 *	@o
 *		Atom *type_return; 	ZNVRo[gl̃vpeB^
 *							Ԃ܂
 *		XtPointer *value_return;	
 *							ZNVRo[gl̃AhXԂ
 *							܂B
 *		unsigned long *length_return;	
 *							value_return ɓꂽl̒Aformat_return 
 *							Ɏw肳ꂽPʂŕԂ܂B
 *		int *format_return;	value_return ɓĂ length_return ̗v
 *							f̂ꂼ̑傫rbgPʂŎw肵܂B
 *							8C16C32̂ꂩłȂ΂Ȃ܂B
 *							̏ɂAwT[oKvȏꍇɂ́AoC
 *							gXbvs܂B
 *	Ԃl
 *		False		Ro[gs
 *		True		Ro[g
 *	
 *		@See. The Definitive Guides to the X Window System
 *			X Toolkit Intrinsics Reference Manual (Editd by David Flanagan)
 ***************************************************************************/
/* ARGSUSED */
static Boolean convert_proc(Widget w, Atom *selection, Atom *target,
				Atom *type_return, XtPointer *value_return, 
				unsigned long *length_return, int *format_return)
{
	String buffer;
	extern StringsLink *copyBufferList;
	XSelectionRequestEvent *req = XtGetSelectionRequest(w, 
											*selection, (XtRequestId) NULL);

	/* handle all required atoms, and the one that we use */
	if (*target == XA_TARGETS(XtDisplay(w))) {
		/* TARGETS handling copied from xclipboard.c */
		Atom* targetP;
		Atom* std_targets;
		unsigned long std_length;
		XmuConvertStandardSelection(w, req->time, selection, 
				target, type_return,
				(XtPointer*)&std_targets, 
				&std_length, format_return);
		*value_return = XtMalloc(sizeof(Atom)*(std_length + 1));
		targetP = *(Atom**)value_return;
		*length_return = std_length + 1;
		*targetP++ = AcTreeAtom;
		bcopy((char*)std_targets, (char*)targetP, sizeof(Atom)*std_length);
		XtFree((char*)std_targets);
		*type_return = XA_ATOM;
		*format_return = sizeof(Atom) * 8;
		return(True);
	}
	/* Xt already handles MULTIPLE, no branch necessary */ 
	else if (*target == AcTreeAtom) {
		if(*value_return = (XtPointer)stringsLink2string(copyBufferList)) {
			*type_return = AcTreeAtom;
			*length_return = strlen(*value_return);
			*format_return = 8;
			return(True);
		} else {
			return(False);
		}
	}
	else { 
		if (XmuConvertStandardSelection(w, CurrentTime, selection, 
				target, type_return, value_return, 
				length_return, format_return))
				return True;
		else {
			XtWarning("waveChart: requestor is requesting"
					" unsupported selection target type.\n");
			return(False);
		}
	}
}

/***************************************************************************
 *	requestor_callback: vꂽZNVf[^ɌĂ΂
 *	`
 *		static void requestor_callback(Widget w, Atom *selection, Atom *target,
 *						Atom *type_return, XtPointer *value_return, 
 *						unsigned long *length_return, int *format_return);
 *	
 *	@
 *		Widget w;				ZNVlvEBWFbgw
 *		XtPointer client_data;	ZNVlvƂɂ̊֐Ƃ
 *								ɓo^f[^w肵܂B
 *		Atom *selection;		vĂZNVw肵܂B
 *		Atom *type;		 		ZNVl̕\nw肵܂B
 *		XtPointer value;		ZNVlւ̃|C^w肵܂B
 *		unsigned long *length;	l̗̒vfw肵܂B
 *		int *format;			l̃f[^vf̑傫rbgPʂŎw肵
 *								܂B
 *	
 *		@See. The Definitive Guides to the X Window System
 *			X Toolkit Intrinsics Reference Manual (Editd by David Flanagan)
 ***************************************************************************/
/* ARGSUSED */
static void requestor_callback(Widget w, XtPointer client_data, 
				Atom *selection, Atom *type, 
				XtPointer value, unsigned long *length, int *format)
{
	if ((value == NULL) && (*length == 0)) {
		XBell(XtDisplay(w), 100);
		XtWarning("SelectionMenu: no selection or selection timed out;"
					" try again\n");
	} else {
		PasteInfo.type = *type;
		PasteInfo.value = value;
		PasteInfo.length = *length;
		PasteInfo.format = *format;
	}
}

/***************************************************************************
 *	preSelectionMenu: ZNVEj[̑IEs\
 *	`
 *		static void preSelectionMenu(Widget w, 
 *								XtPointer client_data, XtPointer garbage);
 *	
 *		Widget w;				EBWFbg
 *		XtPointer client_data;	Ij[ԍ
 *		XtPointer garbage;		gp
 *	
 *		@
 ***************************************************************************/
/* ARGSUSED */
void preSelectionMenu(Widget w, XtPointer client_data, XtPointer garbage)
{
	Boolean sensitive;
	extern Widget pcmWave;
	struct menuData *menuInfo = (struct menuData*) client_data;

	sensitive = XawIsWaveChartSelecting(pcmWave);

	XtSetSensitive((menuInfo->info+1)->myWidget, sensitive);
	XtSetSensitive((menuInfo->info+3)->myWidget, (PasteInfo.value != NULL));
	XtSetSensitive((menuInfo->info+5)->myWidget, sensitive);
	XtSetSensitive((menuInfo->info+6)->myWidget, sensitive);
	XtSetSensitive((menuInfo->info+8)->myWidget, sensitive);
}


/***********************************************************************
 *
 * WaveChart Widget
 *
 ***********************************************************************/

#include <stdio.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/XawInit.h>
#include <X11/Xfuncs.h>
#include <X11/Xatom.h>
#include <X11/Xmu/Atoms.h>
#include "WaveChartP.h"

#define EXPERIMENT_IMPLEMENT
/* Private Data */

#define offset(field) XtOffsetOf(WaveChartRec, field)

static XtResource resources[] =
{
	{XtNwidth, XtCWidth, XtRDimension, sizeof(Dimension),
		 offset(core.width), XtRImmediate, (XtPointer) 120},
	{XtNheight, XtCHeight, XtRDimension, sizeof(Dimension),
		 offset(core.height), XtRImmediate, (XtPointer) 120},
	{XtNminScale, XtCScale, XtRInt, sizeof(int),
		 offset(wave_chart.min_scale), XtRImmediate, (XtPointer) 1},
	{XtNforeground, XtCForeground, XtRPixel, sizeof(Pixel),
		 offset(wave_chart.fgpixel), XtRString, XtDefaultForeground},
	{XtNhighlight, XtCForeground, XtRPixel, sizeof(Pixel),
		 offset(wave_chart.hipixel), XtRString, XtDefaultForeground},
	{XtNcaretPixel, XtCForeground, XtRPixel, sizeof(Pixel),
		 offset(wave_chart.caretPixel), XtRString, XtDefaultForeground},
	{XtNtopLimit, XtCYCoordinate, XtRInt, sizeof(int),
		 offset(wave_chart.topLimit), XtRImmediate, (XtPointer) 1},
	{XtNbottomLimit, XtCXCoordinate, XtRInt, sizeof(int),
		 offset(wave_chart.bottomLimit), XtRImmediate, (XtPointer) -1},
	{XtNleftLimit, XtCYCoordinate, XtRInt, sizeof(int),
		 offset(wave_chart.leftLimit), XtRImmediate, (XtPointer) 0},
	{XtNrightLimit, XtCXCoordinate, XtRInt, sizeof(int),
		 offset(wave_chart.rightLimit), XtRImmediate, (XtPointer) 100},
	{XtNcallback, XtCCallback, XtRCallback, sizeof(XtPointer),
		 offset(wave_chart.callbacks), XtRCallback, (XtPointer)NULL},
	{XtNselectConvert, XtCCallback, XtRCallback, sizeof(XtPointer),
		 offset(wave_chart.selectConvert), XtRCallback, (XtPointer)NULL},
	{XtNselectPaste, XtCCallback, XtRCallback, sizeof(XtPointer),
		 offset(wave_chart.selectPaste), XtRCallback, (XtPointer)NULL},
	{XtNselectCut, XtCCallback, XtRCallback, sizeof(XtPointer),
		 offset(wave_chart.selectCut), XtRCallback, (XtPointer)NULL},
	{XtNcaretFlag, XtCCaretFlag, XtRBoolean, sizeof(Boolean),
		 offset(wave_chart.caretFlag), XtRImmediate, (XtPointer) False},
};

#undef offset

static void Initialize(), Destroy(), Redisplay(), MoveChart(), SetPoints();
static Boolean SetValues();
static int repaint_window();
static void Realize(Widget w, 
					Mask *valueMask, XSetWindowAttributes *attributes);
static void Resize(Widget w);

static void SelectStart(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);
static void SelectAdjust(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);
static void SelectEnd(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);
static void ExtendStart(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);
static void ExtendAdjust(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);
static void SelectPaste(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);
static void SelectCut(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);
static void SelectClear(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);

static Boolean convert_proc(Widget w, Atom *selection, Atom *target,
				Atom *type_return, XtPointer *value_return, 
				unsigned long *length_return, int *format_return);
static void lose_proc(Widget w, Atom *selection);
static void (*addLose_proc)(Widget w) = NULL;
static void SelectCutCall(Widget w);
static void requestor_callback(Widget w, XtPointer client_data, 
				Atom *selection, Atom *type, 
				XtPointer value, unsigned long *length, int *format);
static void Unselect(Widget w, XEvent *event, 
							String *params, Cardinal *num_params);

/* Action Table */
static char defaultTranslations[] = 
	"<Btn1Down>:	select-start()	\n"
	"<Btn1Motion>:	select-adjust()	\n"
	"<Btn1Up>:		select-end()	\n"
	"<Btn2Down>:	select-paste()	\n"
	"<Btn3Down>:	extend-start()	\n"
	"<Btn3Motion>:	extend-adjust()";

XtActionsRec _XawWaveChartActionsTable[] = {
/* Selection stuff */
  {"select-start", 		SelectStart},
  {"select-adjust", 	SelectAdjust},
  {"select-end", 		SelectEnd},
  {"select-paste", 		SelectPaste},
  {"select-unselect", 	Unselect},
  {"select-cut", 		SelectCut},
  {"select-clear", 		SelectClear},
  {"extend-start", 		ExtendStart},
  {"extend-adjust", 	ExtendAdjust},
};

Cardinal _XawWaveChartActionsTableCount = XtNumber(_XawWaveChartActionsTable);

WaveChartClassRec waveChartClassRec =
{
	{		/* core fields */
		/* superclass				*/ (WidgetClass) & simpleClassRec,
		/* class_name				*/ "WaveChart",
		/* size						*/ sizeof(WaveChartRec),
		/* class_initialize			*/ XawInitializeWidgetSet,
		/* class_part_initialize	*/ NULL,
		/* class_inited				*/ FALSE,
		/* initialize				*/ Initialize,
		/* initialize_hook			*/ NULL,
#ifdef	OLD
		/* realize					*/ XtInheritRealize,
#else
		/* realize					*/ Realize,
#endif /*OLD*/
		/* actions					*/ _XawWaveChartActionsTable,
		/* num_actions				*/ XtNumber(_XawWaveChartActionsTable),
		/* resources				*/ resources,
		/* num_resources			*/ XtNumber(resources),
		/* xrm_class				*/ NULLQUARK,
		/* compress_motion			*/ TRUE,
		/* compress_exposure		*/ XtExposeCompressMultiple |
										XtExposeGraphicsExposeMerged,
		/* compress_enterleave		*/ TRUE,
		/* visible_interest			*/ FALSE,
		/* destroy					*/ Destroy,
		/* resize					*/ Resize,
		/* expose					*/ Redisplay,
		/* set_values				*/ SetValues,
		/* set_values_hook			*/ NULL,
		/* set_values_almost		*/ NULL,
		/* get_values_hook			*/ NULL,
		/* accept_focus				*/ NULL,
		/* version					*/ XtVersion,
		/* callback_private			*/ NULL,
		/* tm_table					*/ defaultTranslations,
		/* query_geometry			*/ XtInheritQueryGeometry,
		/* display_accelerator		*/ XtInheritDisplayAccelerator,
		/* extension				*/ NULL
	},
	{		/* Simple class fields */
		/* change_sensitive			*/ XtInheritChangeSensitive
	}
};

WidgetClass waveChartWidgetClass = (WidgetClass) & waveChartClassRec;

/****************************************************************
 *
 * Private Procedures
 *
 ****************************************************************/

static void draw_it();

/***************************************************************************
 *	selectOff: Ï
 *	`
 *		static int selectOff(WaveChartWidget wW);
 *	
 *		WaveChartWidget wW;
 *	
 *		@ÏB̓Iɂ́AI͈͂w肷邽߂Ɏg
 *		ϐāAOtĕ`悵Ĕ]\NA܂B
 ***************************************************************************/
static int selectOff(WaveChartWidget wW)
{
	int result = FALSE;
	int inverseLeft, inverseRight;

#ifdef	DEBUG
	printf("Select [%d -- %d] coordinate.\n", 
					wW->wave_chart.selectStart, wW->wave_chart.selectEnd);
#endif	/*DEBUG*/
	wW->wave_chart.selection = False;
	if(wW->wave_chart.selectStart != wW->wave_chart.selectEnd) {
		inverseLeft  = scaleX2pixelX(wW, wW->wave_chart.selectStart);
		inverseRight = scaleX2pixelX(wW, wW->wave_chart.selectEnd);
#ifdef	DEBUG
		printf("Select [%d -- %d] pixel.\n", inverseLeft, inverseRight);
#endif	/*DEBUG*/
		if(inverseRight < wW->core.width - 1)
			++inverseRight;
		XCopyPlane(XtDisplay(wW), wW->wave_chart.graph_pixmap, 
						XtWindow(wW), wW->wave_chart.fgGC, 
						inverseLeft, 0, inverseRight - inverseLeft, 
						wW->core.height, inverseLeft, wW->core.y, 1L);
		(void) repaint_window(wW, inverseLeft, inverseRight - inverseLeft);
		result = TRUE;
		wW->wave_chart.selectStart = -1;
		wW->wave_chart.selectEnd   = -1;
	}
	return(result);
}

/***************************************************************************
 *	SelectStart: IJnANV
 *	`
 *		static void SelectStart(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				EBWFbg
 *		XEvent *event;			Cxg
 *		String *params;			gp
 *		Cardinal *num_params;	gp
 *	Ԃl
 *		Ȃ
 *	
 *		@IJnANVB
 *		@̑ÏNABOt̂wWɂđI͈͂
 *		vCx[gϐݒ肵܂B܂AI͈͂𔽓]\܂B
 ***************************************************************************/
/* ARGSUSED */
static void SelectStart(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	int graphWidth;
	int inverseLeft, inverseRight;
	WaveChartWidget wW = (WaveChartWidget)w;

	selectOff(wW);
	if (event->type == ButtonPress) {
		graphWidth   = wW->wave_chart.rightLimit - wW->wave_chart.leftLimit;
		inverseLeft  = graphWidth * event->xbutton.x / wW->core.width;
		inverseRight = graphWidth * (event->xbutton.x + 1) / wW->core.width;
	 	inverseLeft  += wW->wave_chart.leftLimit;
	 	inverseRight += wW->wave_chart.leftLimit;
		wW->wave_chart.selectStart = inverseLeft;
		wW->wave_chart.selectEnd  = inverseRight;
		wW->wave_chart.selectBase = wW->wave_chart.selectStart;
	}
	WaveRedisplay(wW, event->xbutton.x, 1);
	(void) repaint_window(wW, event->xbutton.x, 1);
}

/***************************************************************************
 *	SelectEnd: IIANV
 *	`
 *		static void SelectEnd(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				EBWFbg
 *		XEvent *event;			Cxg
 *		String *params;			gp
 *		Cardinal *num_params;	gp
 *	Ԃl
 *		Ȃ
 *	
 *		@
 *		
 ***************************************************************************/
/* ARGSUSED */
static void SelectEnd(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	int graphWidth;
	int currentPos, nextPos;
	WaveChartWidget wW = (WaveChartWidget)w;

	if (event->type == ButtonRelease) {
		graphWidth = wW->wave_chart.rightLimit - wW->wave_chart.leftLimit;
		currentPos = graphWidth * event->xbutton.x / wW->core.width;
		nextPos = graphWidth * (event->xbutton.x + 1) / wW->core.width;
		if(wW->wave_chart.selectBase >= currentPos && 
						wW->wave_chart.selectBase < nextPos) {
			wW->wave_chart.caret = graphWidth * event->xbutton.x / wW->core.width;
			wW->wave_chart.selectStart = wW->wave_chart.selectEnd = 
										wW->wave_chart.selectBase = -1;
			WaveRedisplay(wW, 0, wW->core.width);
			(void) repaint_window(wW, 0, wW->core.width);
			return;
		}
		if (XtOwnSelection((Widget)wW, XA_PRIMARY, event->xbutton.time, 
				convert_proc, lose_proc, NULL/*done_proc*/) == False) {
			XtWarning("WaveChart: failed attempting to become "
					"selection owner; make a new selection.\n");
			WaveRedisplay(wW, 0, wW->core.width);
			(void) repaint_window(wW, 0, wW->core.width);
			wW->wave_chart.selection = False;
		} else {
			wW->wave_chart.selection = True;
		}
	}
	return;
}

/***************************************************************************
 *	SelectAdjust: I͈͂ύXANV
 *	`
 *		static void SelectAdjust(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				EBWFbg
 *		XEvent *event;			Cxg
 *		String *params;			gp
 *		Cardinal *num_params;	gp
 *	Ԃl
 *		Ȃ
 *	
 *		@}EẌړɑΉāAI͈͂ύX
 *		
 ***************************************************************************/
/* ARGSUSED */
static void SelectAdjust(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	int graphWidth;
	int inverseLeft, inverseRight;
	WaveChartWidget wW = (WaveChartWidget)w;

	if (event->type == MotionNotify) {
		graphWidth = wW->wave_chart.rightLimit - wW->wave_chart.leftLimit;
		inverseLeft  = graphWidth * event->xmotion.x / wW->core.width;
		inverseRight = graphWidth * (event->xmotion.x + 1) / wW->core.width;
	 	inverseLeft  += wW->wave_chart.leftLimit;
	 	inverseRight += wW->wave_chart.leftLimit;
	 	if(inverseLeft < wW->wave_chart.selectBase) {
			wW->wave_chart.selectStart = inverseLeft;
			wW->wave_chart.selectEnd = wW->wave_chart.selectBase;
		}
	 	if(inverseRight > wW->wave_chart.selectBase) {
			wW->wave_chart.selectStart = wW->wave_chart.selectBase;
			wW->wave_chart.selectEnd = inverseRight;
		}
	}
	WaveRedisplay(wW, 0, wW->core.width);
	(void) repaint_window(wW, 0, wW->core.width);
}

/***************************************************************************
 *	SelectPaste: y[XgANV
 *	`
 *		static void  SelectPaste(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				EBWFbg
 *		XEvent *event;			Cxg
 *		String *params;			gp
 *		Cardinal *num_params;	gp
 *	Ԃl
 *		Ȃ
 *	
 *		@
 *		
 ***************************************************************************/
/* ARGSUSED */
static void SelectPaste(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	WaveChartWidget wW = (WaveChartWidget)w;

	XtGetSelectionValue((Widget)wW, XA_PRIMARY, wW->wave_chart.target_atom, 
								requestor_callback, event, event->xbutton.time);
}

/***************************************************************************
 *	SelectCut: JbgEANV
 *	`
 *		static void  SelectCut(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				EBWFbg
 *		XEvent *event;			gp
 *		String *params;			gp
 *		Cardinal *num_params;	gp
 *	Ԃl
 *		Ȃ
 *	
 *		@ZNV̏LƂɁAJbgp̃R[obN֐
 *		Ăяo悤ɓo^B
 ***************************************************************************/
/* ARGSUSED */
static void SelectCut(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	WaveChartWidget wW = (WaveChartWidget)w;

	addLose_proc = SelectCutCall;
}

/***************************************************************************
 *	SelectClear: NAEANV
 *	`
 *		static void  SelectClear(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				EBWFbg
 *		XEvent *event;			gp
 *		String *params;			gp
 *		Cardinal *num_params;	gp
 *	Ԃl
 *		Ȃ
 *	
 *		@Jbgp̃R[obN֐ĂяoB
 *		
 ***************************************************************************/
/* ARGSUSED */
static void SelectClear(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	SelectCutCall(w);
	XawWaveSelectionInit(w);
}

/***************************************************************************
 *	SelectCutCall: Jbgp̃R[obN֐ĂяoB
 *	`
 *		static void  SelectCut(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				EBWFbg
 *	Ԃl
 *		Ȃ
 *	
 *		@Jbgp̃R[obN֐ĂяoB
 *		
 ***************************************************************************/
/* ARGSUSED */
static void SelectCutCall(Widget w)
{
	WaveChartWidget wW = (WaveChartWidget)w;
	XawWaveSelectionArea selectionInfo;

	if(wW->wave_chart.selectStart < wW->wave_chart.selectEnd) {
		selectionInfo.selectStart = wW->wave_chart.selectStart;
		selectionInfo.selectEnd   = wW->wave_chart.selectEnd;
		XtCallCallbackList((Widget)wW, 
						wW->wave_chart.selectCut, (XtPointer)&selectionInfo);
		ReDrawGraph(wW);
	}
}

/***************************************************************************
 *	Unselect: EANV
 *	`
 *		static void  Unselect(Widget w, XEvent *event, 
 *								String *params, Cardinal *num_params);
 *	
 *		Widget w;				EBWFbg
 *		XEvent *event;			gp
 *		String *params;			gp
 *		Cardinal *num_params;	gp
 *	Ԃl
 *		Ȃ
 *	
 *		@
 *		
 ***************************************************************************/
/* ARGSUSED */
static void Unselect(Widget w, XEvent *event, 
							String *params, Cardinal *num_params)
{
	WaveChartWidget wW = (WaveChartWidget)w;

	if(wW->wave_chart.selectStart < wW->wave_chart.selectEnd) {
		selectOff(wW);
		XtDisownSelection((Widget)wW, XA_PRIMARY, event->xbutton.time);
	}
}

/***************************************************************************
 *	convert_proc: vꂽZNVf[^Ԃ֐
 *	`
 *		static Boolean convert_proc(Widget w, Atom *selection, Atom *target,
 *						Atom *type_return, XtPointer *value_return, 
 *						unsigned long *length_return, int *format_return);
 *	
 *	@
 *		Widget w;			ZNVLĂEBWFbg
 *		Atom *selection;	vꂽZNV̖OłAgw
 *		Atom *target;		ZNVɗv̌^w肵܂
 *								
 *	@o
 *		Atom *type_return; 	ZNVRo[gl̃vpeB^
 *							Ԃ܂
 *		XtPointer *value_return;	
 *							ZNVRo[gl̃AhXԂ
 *							܂B
 *		unsigned long *length_return;	
 *							value_return ɓꂽl̒Aformat_return 
 *							Ɏw肳ꂽPʂŕԂ܂B
 *		int *format_return;	value_return ɓĂ length_return ̗v
 *							f̂ꂼ̑傫rbgPʂŎw肵܂B
 *							8C16C32̂ꂩłȂ΂Ȃ܂B
 *							̏ɂAwT[oKvȏꍇɂ́AoC
 *							gXbvs܂B
 *	Ԃl
 *		False		Ro[gs
 *		True		Ro[g
 *	
 *		@See. The Definitive Guides to the X Window System
 *			X Toolkit Intrinsics Reference Manual (Editd by David Flanagan)
 ***************************************************************************/
/* ARGSUSED */
static Boolean convert_proc(Widget w, Atom *selection, Atom *target,
				Atom *type_return, XtPointer *value_return, 
				unsigned long *length_return, int *format_return)
{
	WaveChartWidget wW = (WaveChartWidget)w;
	XawWaveSelectionConvert selectionInfo;
	XSelectionRequestEvent *req = XtGetSelectionRequest(w, 
			*selection, (XtRequestId) NULL);

	/* handle all required atoms, and the one that we use */
	if (*target == XA_TARGETS(XtDisplay(wW))) {
		/* TARGETS handling copied from xclipboard.c */
		Atom* targetP;
		Atom* std_targets;
		unsigned long std_length;
		XmuConvertStandardSelection(wW, req->time, selection, 
				target, type_return,
				(XtPointer*)&std_targets, 
				&std_length, format_return);
		*value_return = XtMalloc(sizeof(Atom)*(std_length + 1));
		targetP = *(Atom**)value_return;
		*length_return = std_length + 1;
		*targetP++ = wW->wave_chart.target_atom;
		bcopy((char*)std_targets, (char*)targetP, sizeof(Atom)*std_length);
		XtFree((char*)std_targets);
		*type_return = XA_ATOM;
		*format_return = sizeof(Atom) * 8;
		return(True);
	}
	/* Xt already handles MULTIPLE, no branch necessary */ 
	else if (*target == wW->wave_chart.target_atom) {
		selectionInfo.status = FALSE;	/*  */
		selectionInfo.type_return = type_return;
		selectionInfo.value_return = value_return;
		selectionInfo.length_return = length_return;
		selectionInfo.format_return = format_return;
		selectionInfo.selectStart = wW->wave_chart.selectStart;
		selectionInfo.selectEnd   = wW->wave_chart.selectEnd;
		XtCallCallbackList((Widget)wW, 
				wW->wave_chart.selectConvert, (XtPointer)&selectionInfo);
		*(selectionInfo.type_return) = wW->wave_chart.target_atom;
		return(selectionInfo.status);
	}
	else { 
		if (XmuConvertStandardSelection(wW, CurrentTime, selection, 
				target, type_return, value_return, 
				length_return, format_return))
				return True;
		else {
			XtWarning("waveChart: requestor is requesting"
					" unsupported selection target type.\n");
			return(False);
		}
	}
}

/***************************************************************************
 *	requestor_callback: vꂽZNVf[^ɌĂ΂
 *	`
 *		static void requestor_callback(Widget w, Atom *selection, Atom *target,
 *						Atom *type_return, XtPointer *value_return, 
 *						unsigned long *length_return, int *format_return);
 *	
 *	@
 *		Widget w;				ZNVlvEBWFbgw
 *		XtPointer client_data;	ZNVlvƂɂ̊֐Ƃ
 *								ɓo^f[^w肵܂B
 *		Atom *selection;		vĂZNVw肵܂B
 *		Atom *type;		 		ZNVl̕\nw肵܂B
 *		XtPointer value;		ZNVlւ̃|C^w肵܂B
 *		unsigned long *length;	l̗̒vfw肵܂B
 *		int *format;			l̃f[^vf̑傫rbgPʂŎw肵
 *								܂B
 *	
 *		@See. The Definitive Guides to the X Window System
 *			X Toolkit Intrinsics Reference Manual (Editd by David Flanagan)
 ***************************************************************************/
/* ARGSUSED */
static void requestor_callback(Widget w, XtPointer client_data, 
				Atom *selection, Atom *type, 
				XtPointer value, unsigned long *length, int *format)
{
	String value;
	unsigned long length;

	if ((value == NULL) && (*length == 0)) {
		XBell(XtDisplay(wW), 100);
		XtWarning("no selection or selection timed out; try again\n");
	} else {
		value = value;
		length = *length;
		/* y[Xg[` */
		XtFree(value);
	}
}

/***************************************************************************
 *	lose_proc: ZNV̏L҂LƂm点֐
 *	`
 *		static void lose_proc(Widget w, Atom *selection, Atom *target,
 *						Atom *type_return, XtPointer *value_return, 
 *						unsigned long *length_return, int *format_return);
 *	
 *	@
 *		Widget w;			ZNV̏LEBWFbgw
 *		Atom *selection;	ZNVAgw肵܂B
 *	
 *		@See. The Definitive Guides to the X Window System
 *			X Toolkit Intrinsics Reference Manual (Editd by David Flanagan)
 ***************************************************************************/
/* ARGSUSED */
static void lose_proc(Widget w, Atom *selection)
{
	WaveChartWidget wW = (WaveChartWidget)w;

	if(addLose_proc != NULL) {
		addLose_proc(w);
		addLose_proc = NULL;
	}
	wW->wave_chart.selection = False;
	selectOff(wW);
	Redisplay((Widget)wW, NULL, NULL);
}

/***************************************************************************
 *	SelectArea: vꂽZNVf[^Ԃ֐
 *	`
 *		static Boolean SelectArea(Widget w, 
 *								size_t *selectStart, size_t *selectEnd);
 *	
 *		Widget w;				ZNVLĂEBWFbg
 *		size_t *selectStart;	ZNV̊Jnʒu
 *		size_t *selectEnd;		ZNV̏Iʒu
 *	Ԃl
 *		False		s
 *		True		
 *	
 *		@
 ***************************************************************************/
/* ARGSUSED */
Boolean SelectArea(Widget w, size_t *selectStart, size_t *selectEnd)
{
	Boolean flag = FALSE;
	WaveChartWidget wW = (WaveChartWidget)w;

	if(wW->wave_chart.selectStart < wW->wave_chart.selectEnd) {
		if(selectStart != NULL)
			*selectStart = wW->wave_chart.selectStart;
		if(selectEnd != NULL)
			*selectEnd   = wW->wave_chart.selectEnd;
		flag = TRUE;
	}
	return(flag);
}

/***************************************************************************
 *	XawIsWaveChartSelecting: vꂽZNVf[^Ԃ֐
 *	`
 *		Boolean XawIsWaveChartSelecting(Widget w);
 *	
 *		Widget w;				ZNVLĂEBWFbg
 *	Ԃl
 *		False		s
 *		True		
 *	
 *		@
 ***************************************************************************/
/* ARGSUSED */
Boolean XawIsWaveChartSelecting(Widget w)
{
	WaveChartWidget wW = (WaveChartWidget)w;

	return(wW->wave_chart.selection);
}

/***************************************************************************
 *	XawWaveAllClear: 
 *	`
 *		void XawWaveAllClear(Widget w);
 *	
 *		Widget w;				ZNVLĂEBWFbg
 *	
 *		@
 ***************************************************************************/
/* ARGSUSED */
void XawWaveAllClear(Widget w)
{
	WaveChartWidget wW = (WaveChartWidget) w;

	if (XtIsRealized((Widget) w)) {
		XFillRectangle(XtDisplay(w), wW->wave_chart.graph_pixmap, 
			wW->wave_chart.gp_inv_gc, 0, 0, wW->core.width, wW->core.height);
	}
	if (wW->wave_chart.selection) {
		XtDisownSelection((Widget)wW, XA_PRIMARY, 
								XtLastTimestampProcessed(XtDisplay(wW)));
	}
	wW->wave_chart.selection = False;
	wW->wave_chart.selectBase = 
		wW->wave_chart.selectStart =  wW->wave_chart.selectEnd = -1;
	wW->wave_chart.caret = 0;
	Redisplay((Widget)wW, NULL, NULL);
}

/***************************************************************************
 *	XawWaveSelectionInit: 
 *	`
 *		void XawWaveSelectionInit(Widget w);
 *	
 *		Widget w;				ZNVLĂEBWFbg
 *	
 *		@
 ***************************************************************************/
/* ARGSUSED */
void XawWaveSelectionInit(Widget w)
{
	WaveChartWidget wW = (WaveChartWidget) w;

	if (wW->wave_chart.selection) {
		XtDisownSelection((Widget)wW, XA_PRIMARY, 
								XtLastTimestampProcessed(XtDisplay(wW)));
	}
	wW->wave_chart.selection = False;
	wW->wave_chart.selectBase = 
		wW->wave_chart.selectStart =  wW->wave_chart.selectEnd = -1;
	wW->wave_chart.caret = 0;
	Redisplay((Widget)wW, NULL, NULL);
}

/******************************************************************
 *	waveChart.h: g`Ǘ֘AipubNwb_t@Cj
 *
 *				Programed by Nobuyuki Maruichi
 *				Adviced by S.Kouno
 *
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208 1983
 *			Tab Size 4 / Shift Width = 4
 *
 *
 *
 ******************************************************************/

#ifndef _XawWaveChart_h
#define _XawWaveChart_h

/***********************************************************************
 *
 * WaveChart Widget
 *
 ***********************************************************************/

/* WaveChart resources:

 Name			     Class				RepType			Default Value
 ----			     -----				-------			-------------
 accelerators	     Accelerators		AcceleratorTable NULL
 ancestorSensitive   AncestorSensitive	Boolean			True 
 background		     Background			Pixel			XtDefaultBackground
 backgroundPixmap    Pixmap				Pixmap			XtUnspecifiedPixmap
 borderColor	     BorderColor		Pixel			XtDefaultForeground
 borderPixmap	     Pixmap				Pixmap			XtUnspecifiedPixmap
 borderWidth	     BorderWidth		Dimension		1
 colormap		     Colormap			Colormap		parent's colormap
 cursor			     Cursor				Cursor			None
 cursorName		     Cursor				String			NULL
 depth			     Depth				int				parent's depth
 destroyCallback     Callback			XtCallbackList	NULL
 foreground		     Foreground			Pixel			XtDefaultForeground
 getValue		     Callback			XtCallbackList	NULL
 height			     Height				Dimension		120
 highlight		     Foreground			Pixel			XtDefaultForeground
 insensitiveBorder   Insensitive		Pixmap			GreyPixmap
 jumpScroll		     JumpScroll			int				1/2 width
 mappedWhenManaged   MappedWhenManaged	Boolean			True
 minScale		     Scale				int				1
 pointerColor	     Foreground			Pixel			XtDefaultForeground
 pointerColorBackground Background		Pixel			XtDefaultBackground
 screen			     Screen				Screen			parent's screen
 sensitive		     Sensitive			Boolean			True
 translations	     Translations		TranslationTable NULL
 width			     Width				Dimension		120
 x				     Position			Position		0
 y				     Position			Position		0
ǉ\[X
 topLimit			 YCoordinate		int				1
 bottomLimit		 YCoordinate		int				-1
 leftLimit			 XCoordinate		int				0
 rightLimit			 XCoordinate		int				100
*/

#define DEFAULT_JUMP -1

#ifndef _XtStringDefs_h_
#define XtNhighlight "highlight"
#endif

#define XtCScale "Scale"
#define XtCXCoordinate	"XCoordinate"
#define XtCYCoordinate	"YCoordinate"
#define XtCCaretFlag	"CaretFlag"

#define XtNminScale "minScale"
#define XtNscale "scale"

#define XtNtopLimit "topLimit"
#define XtNbottomLimit "bottomLimit"
#define XtNleftLimit "leftLimit"
#define XtNrightLimit "rightLimit"

#define XtNselectConvert	"selectConvert"
#define XtNselectPaste		"selectPaste"
#define XtNselectCut		"selectCut"
#define XtNcaretPixel		"caretPixel"
#define XtNcaretFlag		"caretFlag"

#define WAVE_PROPERTY_NAME	"PCM8TOWNS"

typedef struct _WaveChartRec *WaveChartWidget;
typedef struct _WaveChartClassRec *WaveChartWidgetClass;

/***********************************************************************
 *	XawRepaintWave ^FOt`p\
 *		f[^WnF		X̔g`f[^ƈΈɑΉWn
 *		OtWnF		Ot\ɑΉzEBWFbg
 *							ƂWn
 *		EBWFbgWnFEBWFbǧ_ɑΉWn
 *	
 ***********************************************************************/
typedef struct _XawRepaintWave {
	double *wave;				/* Ot`p̐lf[^ */
	unsigned long size;			/* f[^TCY */
	unsigned long virtualWidth;	/* zEBWFbgiOtj */
	unsigned long exposeX;		/* ĕ`JnwW */
	unsigned long exposeWidth;	/* ĕ`敝 */
	unsigned long graphBegin;	/* Ot̊JnwWif[^Wj */
	unsigned long graphWidth;	/* Ot̕if[^Wj */
	unsigned long dataBegin;	/* f[^̊JnwWif[^Wj */
	unsigned long dataWidth;	/* f[^̕if[^Wj */
} XawRepaintWave;

typedef struct _XawWaveSelectionConvert {
	Boolean status;					/* ֐̕Ԃl */
	Atom *type_return;				/* ϊ̃vpeB^Ԃ */
	XtPointer *value_return;		/* ZNVl̊i[ꏊ */
	unsigned long *length_return;	/* ZNVl̗vf̌ */
	int *format_return;				/* ZNVl̗vf̑傫 */
	int selectStart;				/* ZNV͈͂̊Jnʒu */
	int selectEnd;					/* ZNV͈͂̏Iʒu */
} XawWaveSelectionConvert;

typedef struct _XawWaveSelectionPaste {
	XtPointer client_data;
	Atom *selection;				/* vĂZNV */
	Atom *type;						/* ZNVl̕\^܂ */
	XtPointer value;				/* ZNVl̊i[ꏊ */
	unsigned long length;			/* ZNVl̗vf̌ */
	int format;						/* ZNVl̗vf̑傫 */
	int pastePos;					/* y[Xgʒu */
} XawWaveSelectionPaste;

typedef struct _XawWaveSelectionArea {
	int selectStart;				/* ZNV͈͂̊Jnʒu */
	int selectEnd;					/* ZNV͈͂̏Iʒu */
} XawWaveSelectionArea ;

extern WidgetClass waveChartWidgetClass;

void WaveRedrawCall(Widget w);
void MakeWaveGraph(Widget w, const double *wave, int size, 
				int dataBegin, int dataEnd, int graphBegin, int graphEnd);
Boolean SelectArea(Widget w, size_t *selectStart, size_t *selectEnd);
Boolean XawIsWaveChartSelecting(Widget w);
void XawWaveAllClear(Widget w);
void XawWaveSelectionInit(Widget w);

#endif /* _XawWaveChart_h */
/* DON'T ADD STUFF AFTER THIS #endif */
 
